/*
 * archrefcompare.c
 *
 * An arhitectural reference simulator for verifying a hardware implementation
 *
 * Copyright (c) 2017, The Linux Foundation. All rights reserved.
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * About Archrefcompare
 *
 * Archrefcompare is an architectural simulator which verifies proper operation of the Verilog code.
 * It does this by parsing the instruction trace file generated by the Verilog model and reading the
 * executable file, and stepping the architectural reference model in lockstep with the Verilog model,
 * and comparing the state of the reference model and the hardware model after each instruction.
 *
 * Archrefcompare is the successor to sidrefcompare, which was based on the SID simulator. The SID
 * simulator runs glacially slowly and is difficult to maintain, which is why this was created.
 *
 * ===%> QEMU
 *
 * Archrefcompare uses QEMU as its architectural reference model. The QEMU core loop which selects
 * a runnable thread is replaced with an archrefcompare core loop which selects the next thread to execute.
 *
 * ===%> Error detection
 *
 * Archrefcompare detects errors in the RTL using these methods:
 *
 * 1) Register checks. When the RTL writes to a register, it emits a Write Register line into the
 *    trace file. This is parsed by archrefcompare and the value of the register in the reference model
 *    is checked against the value in the register write line after the instruction is executed.
 *
 * 2) Memory checks. When the RTL writes to a memory location, it emits a Write Memory line into the
 *    trace file. This is parsed by archrefcompare and the value of the memory location in the reference
 *    model is checked against the value in the memory write line after the instruction is executed.
 *
 * 3) End-of-test checks. After the entire trace file is parsed, the contents of the memory (both OCM and DDR)
 *    in the RTL model are checked against the contents of the memory in the reference model.
 *
 * ===%> State Change List
 *
 * The state change list is the heart of archrefcompare. Each item in the state change list contains an action
 * specifying whether it is a VERIFY or MODIFY action, and a cycle on which to perform this action.
 *
 * When a "Write Register" or "Write Memory" line is parsed from trace file, a VERIFY entry is added to the
 * state change list for cycle + 1. After the instruction has been executed, the cycle is incremented, and
 * all the VERIFY entries in the state change list (for the current cycle) are checked to ensure the memory
 * locations/registers contain the correct value.
 *
 * A MODIFY action specifies a write of some type, either to register, memory, or TLB entry. A MODIFY action
 * at cycle is executed BEFORE the instruction is executed for cycle. This allows an update to occur before the
 * current instruction if the current instruction is dependent on the update.
 *
 * ===%> Unverifiable instructions
 *
 * Some types of instructions cannot be accurately executed by QEMU  because they are dependent on bits
 * which are not available in simulation. Some examples of these instructions are:
 *
 * 1) Instructions which read peripheral registers.
 *
 * 2) Interrupt status flags.
 *
 * 3) Registers or register bits which have no bypass and update a non-deterministic number of cycles later
 *    (such as INST_CNT, CSR/UCSR DSP overflow bit, etc).
 *
 * Archrefcompare will automatically detect these instructions which cannot be properly exeuted by QEMU.
 * When this condition is detected, archrefcompare will convert the VERIFY items in the state change list
 * for the current instruction into MODIFY items. Stated otherwise, archrefcompare will not call QEMU to
 * execute the instruction if any of the instruction's dependencies are not emulated, and instead will
 * manually update the reference model state to match the hardware state.
 *
 * ===%> Noncacheable reads
 *
 * Noncacheable reads are tricky to handle because the the reads and writes are conceptually synchronous,
 * but at the implementation level are effectively asynchronous.
 *
 * For this case:
 *
 * (1) address X contains value1
 * (2) CANCELLED READ INSN  - NC Read request address X
 * (3) GRADUATED WRITE TO X - NC Write request address X value value2
 * (4) GRADUATED READ INSN - NC Read completes
 *
 * Note: (2) and (4) are the same instruction.
 *
 * A simplistic emulation of the processor would return value2 at (4) because the last write
 * wrote value2 to X. However, the correct value to return is value1 because the original
 * read request occured at (1).
 *
 * The obvious way to handle this would be to trap the read request at (4) and return value1 to QEMU
 * instead of the current value value2. However, this is difficult because QEMU is implemented as a JIT
 * rather than as an interpreter (for performance), and therefore generates memory references inline
 * in the generated code instead of calling a function to read memory.
 *
 * So, in order to handle this situation properly, archrefcompare has an "NC Read buffer" which
 * stores the value at address X at (2). When the instruction which generated the NC read request
 * completes at (4), archrefcompare will "roll back" the value at address X to value1, and
 * then restore address X back to value2 after the instruction completes.
 *
 * (1) address X contains value1
 * (2) CANCELLED READ INSN - NC read request address X
 * (3) GRADUATED WRITE INSN - NC write to address X with value2
 * (4) archrefcompare rolls back address X to value1
 * (5) GRADUATED READ INSN - NC read request gets value 1
 * (6) archrefcompare restores address X to value2
 *
 * Note: (2) and (5) are the same instruction.
 *
 * There is one tricky corner case. If the instruction which generated the NC read request uses
 * two memory operands and both the source1 and dest address are the same address, then this will occur:
 *
 * (1) address X contains value1
 * (2) CANCELLED READ INSN - NC request address X
 * (3) GRADUATED WRITE INSN - NC write to address X with value2
 * (4) archrefcompare rolls back address X to value1
 * (5) GRADUATED INSN READS X WRITES X with value3
 * (6) archrefcompare restores address X to value2
 *
 * Note: (2) and (5) are the same instruction.
 *
 * In this case, the rollback of address X at (6) will overwrite value3, so archrefcompare must
 * disable the restore at (6) if the instruction at (5) uses the same address for both source1 and dest.
 *
 * The NC Read rollback/restore are handled separately from the state change list because the rollback
 * operation leaves the memory in a weird state. If archrefcompare routines read the memory location
 * while the memory location is rolled back, then they will read the wrong data.
 *
 * Therefore, the rollback/restore operations are performed just before/after the instruction is executed.
 *
 * There are three special cases for noncacheable reads:
 *
 * 1) The first special case is when there is a noncacheable read, and the instruction which uses the
 *    value is a dual-memory-operand instruction which reads from and writes to the same address.
 *    In this case, the restore of the memory location would overwrite the new value, so the
 *    restore is not performed.
 *
 * 2) The second special case is when there is a noncacheable read, and the instruction which uses the
 *    value is a dual-memory-operand instruction which reads from and writes to different addresses
 *    in the same cache. One example is a 16-bit instruction which reads from the low half of a 32-bit word
 *    and writes to the upper half of the same 32-bit word. In this case, the rollback needs to only restore
 *    and rollback the exact bits used by the instruction, otherwise it would overwrite the new value.
 *
 * 3) The third special case is when an NC Read occurs and a subsequent NC Write occurs, and the NC Read
 *    reads the value of the NC Write due to a bypass. In this case, there will be a special NC Bypass
 *    line in the trace file to indicate a bypass occurs, and archrefcompare will clear valid flag
 *    on the NC read buffer to discard the old value.
 *
 * ===%> Notes
 *
 * Archrefcompare does not pass or fail based on a write to the test pass/fail addresses.
 * This is intentional.
 *
 * One way to view archrefcompare is that it is a sanity check for tests.
 * For example, a self-checking test can be run on the RTL, but if there is an RTL bug
 * somewhere (such as in a branch instruction to determine the final test pass/fail status)
 * then the test can return a false positive. So archrefcompare ensures that all instructions
 * in the test have executed correctly so the final pass/fail result of the test is trustable.
 */

#include <assert.h>
#include <arpa/inet.h>
#include <ctype.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "cpu.h"
#include "ubicom32cpu.h"

#define NO_FPU_TRAP_CHECK
#define NO_BTB_CHECKS
#define MAX_TRACE_LINE_LENGTH 256

#define TLB_ENTRIES_NUM 64

#define MAPPED_START	0x00000000
#define MAPPED_SIZE	0xb0000000
#define MAPPED_END	((MAPPED_START + MAPPED_SIZE) - 1)

#define FLASH_START	0xb0000000
#define FLASH_SIZE	0x01000000
#define FLASH_END	((FLASH_START + FLASH_SIZE) - 1)

#define DRAM_START	0xc0000000
#define DRAM_SIZE	0x40000000
#define DRAM_END	((DRAM_START + DRAM_SIZE) - 1)

#define OCM_START	0xbffc0000
#define OCM_SIZE	0x40000
#define OCM_END		((OCM_START + OCM_SIZE) - 1)

#define IS_MAPPED_ADDRESS(x) ((x >= MAPPED_START) && (x <= MAPPED_END))
#define IS_FLASH_ADDRESS(x) ((x >= FLASH_START) && (x <= FLASH_END))
#define IS_OCP_ADDRESS(x)  ((x >= 0xb9000000) && (x <= 0xb9000fff))
#define IS_OCM_ADDRESS(x)  ((x >=  OCM_START) && (x <=  OCM_END))
#define IS_DRAM_ADDRESS(x) ((x >= DRAM_START) && (x <= DRAM_END))

/* The first 64 registers are thread-local, and the last 192 registers are shared across all threads. */

#define GLOBAL_REGISTER_OFFSET	0x40

/* MMU page size - 1 = 8kbytes, 3 = 16kbytes */
#define PAGE_MASK	(ocp_mmu[0] & 3)

typedef uint64_t TLB_ENTRY;

int archrefcompare_flag;
int archrefcompare_debug_flag;		// Enable debug prints
uint64_t archrefcompare_pass_flag, archrefcompare_fail_flag;
int DRAM_check_flag = 1;
int OCM_check_flag = 1;
int insn_check_flag = 1;
int TLB_value_check_flag = 1;
int flash_write_check_flag = 1;
int EOT_DDR_check_megabytes_num = 64;
int pc_miscompare_check_flag = 1;
uint32_t init_pc;

int last_thread_num;
uint32_t last_pc_paddr;
uint64_t last_cycle;			/* Clock cycle of last line processed in a block */
uint64_t insn_cycle;			/* Clock cycle of last graduated insn */

FILE *trace_file;

void TLB_write(uint32_t index, uint64_t value, int insn_flag);
void snoop_MMU_read(uint32_t paddr);

typedef struct {

	const char *name;
	UBICOM32_REGISTER num;

} UBICOM32_REGISTER_INFO;

void archrefcompare_abort(void) __attribute__ ((__noreturn__));
void NC_Read_Store(int thread_num, uint32_t vaddr, uint32_t paddr);

/*************************************
* Start useful data
*************************************/

/* Unfortunately we cannot use the tables in translate.c here because the trace files use
   different names for some registers (trace file uses mac_lo, translate.c uses acc0_lo, etc) */

UBICOM32_REGISTER_INFO ubicom32_reg_info[] = {

	{"D0",		REGISTER_D0},
	{"D1",		REGISTER_D1},
	{"D2",		REGISTER_D2},
	{"D3",		REGISTER_D3},
	{"D4",		REGISTER_D4},
	{"D5",		REGISTER_D5},
	{"D6",		REGISTER_D6},
	{"D7",		REGISTER_D7},
	{"D8",		REGISTER_D8},
	{"D9",		REGISTER_D9},
	{"D10",		REGISTER_D10},
	{"D11",		REGISTER_D11},
	{"D12",		REGISTER_D12},
	{"D13",		REGISTER_D13},
	{"D14",		REGISTER_D14},
	{"D15",		REGISTER_D15},

	{"A0",		REGISTER_A0},
	{"A1",		REGISTER_A1},
	{"A2",		REGISTER_A2},
	{"A3",		REGISTER_A3},
	{"A4",		REGISTER_A4},
	{"A5",		REGISTER_A5},
	{"A6",		REGISTER_A6},
	{"A7",		REGISTER_A7},

	{"MAC_HI",	REGISTER_ACC0_HI},
	{"MAC_LO",	REGISTER_ACC0_LO},
	{"MAC_RC16",	REGISTER_MAC_RC16},
	{"SOURCE3",	REGISTER_SOURCE3},
	{"INST_CNT",	REGISTER_INST_CNT},		/* Actually called CONTEXT_CNT in mp.trace, but we don't need to parse it */
	{"CSR",		REGISTER_CSR},
	{"ROSR",	REGISTER_ROSR},
	{"IREAD_DATA",	REGISTER_IREAD_DATA},
	{"INT_MASK0",	REGISTER_INT_MASK0},
	{"INT_MASK1",	REGISTER_INT_MASK1},
	{"INT_MASK2",	REGISTER_INT_MASK2},

	{"PC",		REGISTER_PC},
	{"ACC1_HI",	REGISTER_ACC1_HI},
	{"ACC1_LO",	REGISTER_ACC1_LO},

	{"UCSR",	REGISTER_UCSR},

	/* Global registers */

	{"CHIP_ID",		REGISTER_CHIP_ID},
	{"INT_STAT0",		REGISTER_INT_STAT0},
	{"INT_STAT1",		REGISTER_INT_STAT1},
	{"INT_STAT2",		REGISTER_INT_STAT2},

	{"INT_SET0",		REGISTER_INT_SET0},
	{"INT_SET1",		REGISTER_INT_SET1},
	{"INT_SET2",		REGISTER_INT_SET2},

	{"INT_CLR0",		REGISTER_INT_CLR0},
	{"INT_CLR1",		REGISTER_INT_CLR1},
	{"INT_CLR2",		REGISTER_INT_CLR2},

	{"GLOBAL_CTRL",		REGISTER_GLOBAL_CTRL},
	{"MT_ACTIVE",		REGISTER_MT_ACTIVE},
	{"MT_ACTIVE_SET",	REGISTER_MT_ACTIVE_SET},
	{"MT_ACTIVE_CLR",	REGISTER_MT_ACTIVE_CLR},
	{"MT_DBG_ACTIVE",	REGISTER_MT_DBG_ACTIVE},
	{"MT_DBG_ACTIVE_SET",	REGISTER_MT_DBG_ACTIVE_SET},
	{"MT_EN",		REGISTER_MT_EN},
	{"MT_HPRI",		REGISTER_MT_HPRI},
	{"MT_HRT",		REGISTER_MT_HRT},
	{"MT_BREAK",		REGISTER_MT_BREAK},
	{"MT_BREAK_CLR",	REGISTER_MT_BREAK_CLR},
	{"MT_SINGLE_STEP",	REGISTER_MT_SINGLE_STEP},
	{"MT_MIN_DELAY_EN",	REGISTER_MT_MIN_DELAY_EN},
	{"MT_BREAK_SET",	REGISTER_MT_BREAK_SET},
	{"PERR_ADDR",		REGISTER_PERR_ADDR},
	{"DCAPT",		REGISTER_DCAPT},

	{"MT_DBG_ACTIVE_CLR",	REGISTER_MT_DBG_ACTIVE_CLR},
	{"SCRATCHPAD0",		REGISTER_SCRATCHPAD0},
	{"SCRATCHPAD1",		REGISTER_SCRATCHPAD1},
	{"SCRATCHPAD2",		REGISTER_SCRATCHPAD2},
	{"SCRATCHPAD3",		REGISTER_SCRATCHPAD3},
	{"SCRATCHPAD4",		REGISTER_SCRATCHPAD4},
	{"SCRATCHPAD5",		REGISTER_SCRATCHPAD5},

	{"CFG",			REGISTER_CHIP_CFG},		/* This register is actually "CHIP_CFG" but mp.trace contains "CFG" */
	{"MT_I_BLOCKED",	REGISTER_MT_I_BLOCKED},
	{"MT_D_BLOCKED",	REGISTER_MT_D_BLOCKED},
	{"MT_I_BLOCKED_SET",	REGISTER_MT_I_BLOCKED_SET},
	{"MT_D_BLOCKED_SET",	REGISTER_MT_D_BLOCKED_SET},
	{"MT_BLOCKED_CLR",	REGISTER_MT_BLOCKED_CLR},
	{"MT_TRAP_EN",		REGISTER_MT_TRAP_EN},
	{"MT_TRAP",		REGISTER_MT_TRAP},
	{"MT_TRAP_SET",		REGISTER_MT_TRAP_SET},
	{"MT_TRAP_CLR",		REGISTER_MT_TRAP_CLR},
	{"SEP",			REGISTER_SEP},

	{"MT_BTB_EN",		REGISTER_MT_BTB_EN},
	{"BTB_ENTRIES",		REGISTER_BTB_ENTRIES},
	{"TNUM",		REGISTER_TNUM},

	{"I_RANGE0_HI",		REGISTER_I_RANGE0_HI},
	{"I_RANGE1_HI",		REGISTER_I_RANGE1_HI},
	{"I_RANGE2_HI",		REGISTER_I_RANGE2_HI},
	{"I_RANGE3_HI",		REGISTER_I_RANGE3_HI},

	{"I_RANGE0_LO",		REGISTER_I_RANGE0_LO},
	{"I_RANGE1_LO",		REGISTER_I_RANGE1_LO},
	{"I_RANGE2_LO",		REGISTER_I_RANGE2_LO},
	{"I_RANGE3_LO",		REGISTER_I_RANGE3_LO},

	{"I_RANGE0_EN",		REGISTER_I_RANGE0_EN},
        {"I_RANGE1_EN",		REGISTER_I_RANGE1_EN},
	{"I_RANGE2_EN",		REGISTER_I_RANGE2_EN},
	{"I_RANGE3_EN",		REGISTER_I_RANGE3_EN},

	{"D_RANGE0_HI",		REGISTER_D_RANGE0_HI},
	{"D_RANGE1_HI",		REGISTER_D_RANGE1_HI},
	{"D_RANGE2_HI",		REGISTER_D_RANGE2_HI},
	{"D_RANGE3_HI",		REGISTER_D_RANGE3_HI},
	{"D_RANGE4_HI",		REGISTER_D_RANGE4_HI},
	{"D_RANGE5_HI",		REGISTER_D_RANGE5_HI},

	{"D_RANGE0_HI",		REGISTER_D_RANGE0_HI},
	{"D_RANGE1_HI",		REGISTER_D_RANGE1_HI},
	{"D_RANGE2_HI",		REGISTER_D_RANGE2_HI},
	{"D_RANGE3_HI",		REGISTER_D_RANGE3_HI},
	{"D_RANGE4_HI",		REGISTER_D_RANGE4_HI},

	{"D_RANGE0_EN",		REGISTER_D_RANGE0_EN},
	{"D_RANGE1_EN",		REGISTER_D_RANGE1_EN},
	{"D_RANGE2_EN",		REGISTER_D_RANGE2_EN},
	{"D_RANGE3_EN",		REGISTER_D_RANGE3_EN},
	{"D_RANGE4_EN",		REGISTER_D_RANGE4_EN},

	{"I_RANGE0_USER_EN",	REGISTER_I_RANGE0_USER_EN},
	{"I_RANGE1_USER_EN",	REGISTER_I_RANGE1_USER_EN},
	{"I_RANGE2_USER_EN",	REGISTER_I_RANGE2_USER_EN},
	{"I_RANGE3_USER_EN",	REGISTER_I_RANGE3_USER_EN},

	{"D_RANGE0_USER_EN",	REGISTER_D_RANGE0_USER_EN},
	{"D_RANGE1_USER_EN",	REGISTER_D_RANGE1_USER_EN},
	{"D_RANGE2_USER_EN",	REGISTER_D_RANGE2_USER_EN},
	{"D_RANGE3_USER_EN",	REGISTER_D_RANGE3_USER_EN},
	{"D_RANGE4_USER_EN",	REGISTER_D_RANGE4_USER_EN},
	{"D_RANGE5_USER_EN",	REGISTER_D_RANGE5_USER_EN}

};

/*************************************
* End useful data
*************************************/
/*************************************
* Start end-of-test code
*************************************/

typedef struct {

	uint32_t value, mask;

} DATA_VALUE;

/*
** Convert a string containing [xX0-9a-fA-F] into a value and bitmask.
*/

void Data_Value_Convert(char *string, DATA_VALUE *data);
void Data_Value_Convert(char *string, DATA_VALUE *data)
{
	char c;
	int i;

	data->value = data->mask = 0;

	/* Maximum of 8 digits */

	for (i=0; i<8; i++) {

		c = string[i];

		if (!c || (c == '\n'))
			break;

		data->value <<= 4;
		data->mask  <<= 4;

		if ((c >= '0') && (c <= '9')) {
			data->value |= c - '0';
			data->mask  |= 0xf;
		} else if ((c >= 'a') && (c <= 'f')) {
			data->value |= 10 + (c - 'a');
			data->mask  |= 0xf;
		} else if ((c >= 'A') && (c <= 'F')) {
			data->value |= 10 + (c - 'A');
			data->mask  |= 0xf;
		} else if ((c != 'x') && (c != 'X')) {
			printf("ERROR: bad character '%c' in hex value\n", c);
			archrefcompare_abort();
		}
	}
}

/*
** Compare contents of QEMU DRAM against the ddr.dump file generated by the Verilog simulator.
*/

void EOT_DRAM_Check(void);
void EOT_DRAM_Check(void)
{
	char dfDataS[5], dfLine[256];
	int read_next_range_flag;
	unsigned int i, range_start, range_end;
	uint16_t qemu_value;
	int EOT_DDR_check_bytes_num = EOT_DDR_check_megabytes_num << 20;
	FILE *dumpFile;
	DATA_VALUE data;

	if (!DRAM_check_flag) {
		printf("EOT DRAM check disabled\n");
		return;
	}

	if (!(dumpFile = fopen("ddr.dump", "r" ))) {
		printf("ERROR: Unable to open file ddr.dump\n");
		archrefcompare_abort();
	}

	printf("EOT DRAM check: checking %d megabytes...\n", EOT_DDR_check_megabytes_num);

	range_start = range_end = 0xffffffff;

	/* Force the code to read the first address range from the file. */

	read_next_range_flag = 1;

	/* Set the expected data value to be UNINITIALIZED_VALUE in case the file contains no valid address ranges. */

	data.value = 0;
	data.mask = 0xffff;

	/* Step through the DDR RAM as 16-bit values, because the ddr.dump contains 16-bit values */

	for (i=0; i<EOT_DDR_check_bytes_num; i+=2) {

		if (read_next_range_flag) {

			read_next_range_flag = 0;

			do {
				/* Keep reading lines from the file while they are comments and it's not the end-of-file */

				do {
					fgets(dfLine, 255, dumpFile);
				} while (!feof(dumpFile) && (*dfLine == '#'));

				if (!feof(dumpFile)) {

					sscanf(dfLine, "%x:%x/%4s;", &range_start, &range_end, dfDataS);

					if (range_start > range_end)
						printf("WARNING: Ignored reversed address range %x to %x in ddr.dump\n", range_start, range_end);

					/* The ddr.dump file contains word offsets, so mutiply by two for byte offset */

					range_start <<= 1;
					range_end   <<= 1;

					if (i > range_start) {
						printf("ERROR: Address range %x to %x in ddr.dump overlaps previous address range!\n", range_start >> 1, range_end >> 1);
						archrefcompare_abort();
					}
				}

			/* If the current address range is invalid, then keep retrying until we get a valid one. */

			} while (range_start > range_end);
		}

		/* The current address is equal to the start address of the range, so set the expected value to the value in the address range. */

		if (i == range_start)
			Data_Value_Convert(dfDataS, &data);

		cpu_physical_memory_read(DRAM_START + i, (uint8_t *)&qemu_value, 2);

		qemu_value = htons(qemu_value);

		if ((qemu_value & data.mask) != data.value) {
			printf("ERROR: Data miscompare at address: 0x%08x, RTL value: 0x%04x, QEMU value: 0x%04x with mask %04x\n",
				DRAM_START + i, qemu_value, data.value, data.mask);

			archrefcompare_abort();
		}

		/* The current address is equal to the end address of the range, so set the expected value to the uninitialized value
		   in case the next address range is not contiguous to this address range and/or this is the last address range. */

		if (i == range_end) {
			data.value = 0;
			data.mask = 0xffff;
			read_next_range_flag = 1;
		}
	}

	fclose(dumpFile);

	printf("EOT DRAM check finished\n");
}

/*
** Compare contents of QEMU OCM against the ocm.dump file generated by the Verilog simulator.
*/

void EOT_OCM_Check(void);
void EOT_OCM_Check(void)
{
	char dfLine[256], dfDataS[9];
	int i;
	uint32_t qemu_value;
	FILE *dumpFile;
	DATA_VALUE data;

	if (!OCM_check_flag) {
		printf("EOT OCM check disabled\n");
		return;
	}
	if (!(dumpFile = fopen("ocm.dump", "r" ))) {
		printf("Unable to open file ddr.dump");
		archrefcompare_abort();
	}

	printf("EOT OCM check: checking %x to %x\n", OCM_START, OCM_END);

	for (i=0; i<OCM_SIZE; i+=4) {

		fgets(dfLine, 255, dumpFile);

		if (sscanf(dfLine, "%s", dfDataS) != 1) {
			printf("error: unable to parse line\n");
			archrefcompare_abort();
		}

		Data_Value_Convert(dfDataS, &data);

		cpu_physical_memory_read(OCM_START + i, (uint8_t *)&qemu_value, 4);

		qemu_value = htonl(qemu_value);

		/* Check all 32-bits of data regardless of the mask to emulate sidrefcompare behavior */

		if ((qemu_value & data.mask) != data.value) {
			printf("ERROR: Data miscompare at address: 0x%08x, RTL value: 0x%08x, QEMU value: 0x%08x, mask: 0x%08x\n",
				OCM_START + i, qemu_value, data.value, data.mask);

			archrefcompare_abort();
		}
	}

	fclose(dumpFile);

	printf("EOT OCM check finished\n");
}

/*************************************
* End end-of-test code
*************************************/
/*************************************
* Start register value code
*************************************/

/*
** static int get_register_value(CPUUBICOM32State *state, int register_num)
**
** Get the value of a register from QEMU.
*/

static int get_register_value(CPUUBICOM32State *state, int register_num);
static int get_register_value(CPUUBICOM32State *state, int register_num)
{
	return (register_num < GLOBAL_REGISTER_OFFSET)
		? state->thread_regs[register_num] : state->global_regs[register_num - GLOBAL_REGISTER_OFFSET];
}

static int set_register_value(CPUUBICOM32State *state, int register_num, uint32_t value);
static int set_register_value(CPUUBICOM32State *state, int register_num, uint32_t value)
{
	if (register_num < GLOBAL_REGISTER_OFFSET)
		state->thread_regs[register_num] = value;
	else
		state->global_regs[register_num - GLOBAL_REGISTER_OFFSET] = value;

	return value;
}

/*
** static int check_register_value(CPUUBICOM32State *state, int register_num, uint32_t value, uint32_t mask)
**
** Check the register value from QEMU and check against a mask/value pair.
*/

static int check_register_value(CPUUBICOM32State *state, int register_num, uint32_t value, uint32_t mask);
static int check_register_value(CPUUBICOM32State *state, int register_num, uint32_t value, uint32_t mask)
{
	int flag;
	uint32_t reg_value;

	reg_value = get_register_value(state, register_num);

	flag = (reg_value & mask) == (value & mask);

	return flag;
}

/*************************************
* End register value code
*************************************/
/*************************************
* Start instruction disassembler
*************************************/

/*
** static int insn_operand_size(uint32_t opcode)
**
** Returns the operand size of an insn.
*/

static int insn_operand_size(uint32_t opcode)
{
	switch (opcode >> 27) {

		case 0x00:

			switch ((opcode >> 11) & 0x1f) {

				case 0x01:	/* SUSPEND */
				case 0x03:	/* SYNC */
				case 0x04:	/* RET */
				case 0x05:	/* PREFETCH */
				case 0x07:	/* BKPT */
				case 0x08:	/* SYSRET */
				case 0x09:	/* SYSCALL */

					return 0;

				case 0x0f:	/* MOVE.1 */
				case 0x17:	/* EXT.1 */
				case 0x1f:	/* LEA.1 */

					return 1;

				case 0x0b:	/* NOT.2 */
				case 0x0d:	/* MOVE.2 */
				case 0x15:	/* EXT.2 */
				case 0x18:	/* SWAPB.2 */
				case 0x1a:	/* PXCNV */
				case 0x1b:	/* PXCNV.T */
				case 0x1d:	/* LEA.2 */

					return 2;

				case 0x02:	/* FLUSH */
				case 0x0a:	/* NOT.4 */
				case 0x0c:	/* MOVE.4 */
				case 0x0e:	/* MOVEA */
				case 0x11:	/* FLUSHNI */
				case 0x12:	/* SETCSR */
				case 0x13:	/* TBSET */
				case 0x14:	/* TBCLR */
				case 0x16:	/* INVAL */
				case 0x19:	/* SWAPB.4 */
				case 0x1c:	/* LEA.4 */
				case 0x1e:	/* PDEC */

					return 4;
			}

			printf("insn_operand_size(): Unknown instruction 0x%08x\n", opcode);
			archrefcompare_abort();

		case 0x02:

			switch ((opcode >> 21) & 0x1f) {

				case 0x08:	/* CRCGEN */
				case 0x0a:	/* LSL.1 */
				case 0x0b:	/* LSR.1 */
				case 0x0c:	/* ASR.1 */

					return 1;

				case 0x11:	/* LSL.2 */
				case 0x13:	/* LSR.2 */
				case 0x15:	/* ASR.2 */
				case 0x1e:	/* SHMRG.2 */

					return 2;

				case 0x00:	/* PXHI */
				case 0x02:	/* PXHI.S */
				case 0x06:	/* BTST */
				case 0x10:	/* LSL.4 */
				case 0x12:	/* LSR.4 */
				case 0x14:	/* ASR.4 */
				case 0x16:	/* BFEXTU */
				case 0x18:	/* BFRVS */
				case 0x1a:	/* SHFTD */
				case 0x1c:	/* MERGE */
				case 0x1f:	/* SHMRG.1 */

					return 4;
			}

			printf("insn_operand_size(): Unknown instruction 0x%08x\n", opcode);
			archrefcompare_abort();

		case 0x03:

			/* For floating-point instructions, only the source1 can use the 11-bit encoding.
			   Therefore, the operand size we need for address calculation is the source1 size. */

			switch ((opcode >> 21) & 0x1f) {

				case 0x05: case 0x06:			/* FS2D, FS2L */
				case 0x0b:				/* FS2I */

					return 2;

				case 0x00: case 0x01:			/* FADDS, FSUBS */
				case 0x02: case 0x03:			/* FMULS, FDIVS */
				case 0x04:				/* FI2D */
				case 0x07: case 0x08: case 0x09:	/* FSQRTS, FNEGS, FABSS */
				case 0x0a:				/* FI2S */
				case 0x0c:				/* FCMPS */
				case 0x10: case 0x11:			/* FADD, FSUBD */
				case 0x12: case 0x13:			/* FMULD, FDIVD */
				case 0x14: 				/* FL2S */
				case 0x17: case 0x18: case 0x19:	/* FSQRTD, FNEGD, FABSD */
				case 0x1a: case 0x1b:			/* FL2D, FL2I */
				case 0x1c:				/* FCMPD */

					return 4;

				case 0x15: case 0x16:			/* FD2S, FD2I */

					return 8;
			}

			break;

		case 0x06:

			switch ((opcode >> 21) & 0x1f) {

				case 0x00:	/* MULS */
				case 0x01:	/* MACS */
				case 0x02:	/* MULU */
				case 0x03:	/* MACU */
				case 0x04:	/* MULF */
				case 0x05:	/* MACF */
				case 0x07:	/* MACUS */
				case 0x09:	/* MSUF */
				case 0x11:	/* MADD.2 */
				case 0x13:	/* MSUB.2 */

					return 2;

				case 0x06:	/* MACS.4 */
				case 0x08:	/* MULS.4 */
				case 0x0a:	/* MULU.4 */
				case 0x0b:	/* MACU.4 */
				case 0x10:	/* MADD.4 */
				case 0x12:	/* MSUB.4 */

					return 4;
			}

			printf("insn_operand_size(): Unknown instruction 0x%08x\n", opcode);
			archrefcompare_abort();

		case 0x1a:	/* JMP<cc> */
		case 0x1b:	/* CALL */
		case 0x1e:	/* CALLI, LEAI  */

			return 0;

		case 0x16:	/* PXADD */
		case 0x18:	/* CMPI */

			return 2;

		case 0x08:	/* AND.1, AND.2 */
		case 0x0a:	/* OR.1,  OR.2 */
		case 0x0c:	/* XOR.1, XOR.2 */
		case 0x0e:	/* ADD.1, ADD.2 */
		case 0x11:	/* SUB.1, SUB.2 */

			return (opcode & 0x8000) ? 1 : 2;

		case 0x04:	/* BSET */
		case 0x05:	/* BCLR */
		case 0x09:	/* AND.4 */
		case 0x0b:	/* OR.4 */
		case 0x0d:	/* XOR.4 */
		case 0x0f:	/* ADD.4 */
		case 0x10:	/* ADDC */
		case 0x12:	/* SUB.4 */
		case 0x13:	/* SUBC */
		case 0x14:	/* PXBLEND */
		case 0x15:	/* PXVI */
		case 0x1c:	/* MOVEAI */
		case 0x1d:	/* MOVEAIH */

			return 4;

		case 0x19:	/* MOVEI */

			return 4;
	}

	printf("insn_operand_size(): Unknown instruction 0x%08x\n", opcode);
	archrefcompare_abort();
}

/*
** Identify instruction format
*/

static INSN_FORMAT insn_identify_format(uint32_t opcode);
static INSN_FORMAT insn_identify_format(uint32_t opcode)
{
//	printf("major opcode: 0x%x\n", opcode >> 27);

	switch (opcode >> 27) {

		case 0x00:

			switch ((opcode >> 11) & 0x1f) {

				case 0x00: case 0x01:			/* BKPT, SUSPEND */

					return INSN_FORMAT_1A;

				case 0x04:				/* RET */
				case 0x11:				/* FLUSHNI */
				case 0x16:				/* INVAL */

					return INSN_FORMAT_1B;

				case 0x0a: case 0x0b:			/* NOT.4, NOT.2 */
				case 0x0c: case 0x0d: case 0x0f:	/* MOVE.4, MOVE.2, MOVE.1 */
				case 0x0e:				/* MOVEA */
				case 0x12:				/* SETCSR */
				case 0x15: case 0x17:			/* EXT.2, EXT.1 */
				case 0x18: case 0x19:			/* SWAPB.2, SWAPB.4 */
				case 0x1a: case 0x1b:			/* PXCNV, PXCNV.T */
				case 0x1c: case 0x1d: case 0x1f:	/* LEA.4, LEA.2, LEA.1 */
				case 0x1e:				/* PDEC */

					return INSN_FORMAT_1D;
			}

		case 0x04: case 0x05:	/* BSET, BCLR */

			return INSN_FORMAT_2;

		case 0x08: case 0x09:	/* AND.1, AND.2, AND.4 */
		case 0x0a: case 0x0b:	/* OR.1, OR.2, OR.4 */
		case 0x0e: case 0x0f:	/* ADD.1, ADD.2, ADD.4 */
		case 0x10:		/* ADDC */
		case 0x11: case 0x12:	/* SUB.1, SUB.2, SUB.4 */
		case 0x13:		/* SUBC */
		case 0x14:		/* PXBLEND, PXBLEND.T */
		case 0x15:		/* PXVI, PXVI.S */
		case 0x16:		/* PXADDS, PXADDS.U */
		case 0x0c: case 0x0d:	/* XOR.1, XOR.2, XOR.4 */

			return INSN_FORMAT_3;

		case 0x2:	/* ASR.4, ASR.2, ASR.1, BFEXTU, BFRVS, BTST, CRCGEN */
				/* LSL.4, LSL.2, LSL.1, LSR.4, LSR.2, LSR.1 */
				/* PXHI, PXHI.S, SHFTD, SHMRG.2, SHMRG.1, MERGE */
				/* Note: CRCGEN does not use dest so is technically not 4A or 4B.
				         There should be a 4C format for CRCGEN. */

			return (opcode & BIT_26) ? INSN_FORMAT_4B : INSN_FORMAT_4A;

		case 0x18:	/* CMPI */

			return INSN_FORMAT_5;

		case 0x19:	/* MOVEI */

			return INSN_FORMAT_6;

		case 0x1a:	/* JMP<cc>.C.P */

			return INSN_FORMAT_7;

		case 0x1b:	/* CALL */
		case 0x1c: 	/* MOVEAI */
		case 0x1d:	/* MOVEAIH */

			return INSN_FORMAT_8;

		case 0x1e:

			switch ((opcode >> 11) & 0x1f) {

				case 0x00: case 0x01: case 0x02:	/* CALLI, LEAI, CALLI.B */

					return INSN_FORMAT_9;
			}

			break;

		case 0x06:	/* MULS, MULU, MACS, MACU, MACUS */
				/* MULF, MACF, MSUF */
				/* MULS.4, MULU.4, MADD.4 MADD.2 MSUB.4 MSUB.2 */

			return (opcode & BIT_26) ? INSN_FORMAT_10B : INSN_FORMAT_10A;

		case 0x03:

			switch ((opcode >> 21) & 0x1f) {

				case 0x00: case 0x01:			/* FADDS, FSUBS */
				case 0x02: case 0x03:			/* FMULS, FDIVS */

					return INSN_FORMAT_11A;

				case 0x04: case 0x05: case 0x06:	/* FI2D, FS2D, FS2L */

					return INSN_FORMAT_11B;

				case 0x07: case 0x08: case 0x09:	/* FSQRTS, FNEGS, FABSS */
				case 0x0a: case 0x0b:			/* FI2S, FS2I */

					return INSN_FORMAT_11C;

				case 0x0c:				/* FCMPS */

					return INSN_FORMAT_11D;

				case 0x10: case 0x11:			/* FADD, FSUBD */
				case 0x12: case 0x13:			/* FMULD, FDIVD */

					return INSN_FORMAT_12A;

				case 0x14: case 0x15: case 0x16:	/* FL2S, FD2S, FD2I */

					return INSN_FORMAT_12B;

				case 0x17: case 0x18: case 0x19:	/* FSQRTD, FNEGD, FABSD */
				case 0x1a: case 0x1b:			/* FL2D, FL2I */

					return INSN_FORMAT_12C;

				case 0x1c:				/* FCMPD */

					return INSN_FORMAT_12D;
			}
	}

	printf("insn_identify_format(); unknown instruction format 0x%08x\n", opcode);
	archrefcompare_abort();
}

/*
** static int insn_has_false_read(uint32_t opcode)
**
** Returns 1 if insn only generates an effective address calculation but no actual memory access.
** Returns 0 otherwise.
*/

static int insn_has_false_read(uint32_t opcode)
{
	uint32_t major_op, opcode_ext;

	major_op = opcode >> 26;

	switch (major_op) {

		case 0x00:

			opcode_ext = (opcode >> 11) & 0x1f;

			switch (opcode_ext) {

				case 0x18:	/* JMP<cc>.C.P */
				case 0x1c:	/* LEA.4 */
				case 0x1d:	/* LEA.2 */
				case 0x1f:	/* LEA.1 */

					if (archrefcompare_debug_flag)
						printf("insn has false read: true\n");

					return 1;
			}

			break;
	}

//	printf("insn has false read: false\n");

	return 0;
}

/*
** static int decode_source1_address(int thread_num, uint32_t opcode, uint32_t *vaddr)
**
** Returns 1 if instruction reads memory and returns the address.
** Returns 0 otherwise.
*/

static int decode_source1_address(int thread_num, uint32_t opcode, uint32_t *vaddr)
{
	int areg_index, dreg_index, flag;
	uint32_t addr_mode, base, offset;
	CPUUBICOM32State *env;

	if (insn_has_false_read(opcode))
		return 0;

	/* Instruction format has an 11-bit source1 encoding, so we need to check
	   the actual addressing mode used. */

	env = threads[thread_num];

	addr_mode = opcode & 0x7ff;

	flag = 1;

	switch (addr_mode >> 8) {

		case 0:		/* Immediate */

			flag = 0;
			break;

		case 1:		/* Direct register */

			flag = 0;
			break;

		case 2:		/* Areg + 4 bits scaled offset with pre/post-increment */

			areg_index = REGISTER_A0 + ((addr_mode >> 5) & 7);
			offset     = (addr_mode & 0x10) ? (addr_mode & 0xf) : 0;		/* Offset for this instruction is zero if post-increment */
			base       = get_register_value(env, areg_index);
			*vaddr     = base + offset * insn_operand_size(opcode);
			break;

		case 3:		/* Areg + Dreg */

			areg_index = REGISTER_A0 + ((addr_mode >> 5) & 7);
			dreg_index = REGISTER_D0 + (addr_mode & 0xf);
			base       = get_register_value(env, areg_index);
			offset     = get_register_value(env, dreg_index);
			*vaddr     = base + offset;
			break;

		default:	/* Areg + 7 bits scaled offset */

			areg_index = REGISTER_A0 + ((addr_mode >> 5) & 7);
			offset     = (((addr_mode >> 8) << 5) & 0x60) | (addr_mode & 0x1f);
			base       = get_register_value(env, areg_index);
			*vaddr     = base + offset * insn_operand_size(opcode);
			break;
	}

	return flag;
}

/*
** static int decode_dest_address(int thread_num, uint32_t opcode, uint32_t *vaddr)
**
** Returns 1 if an instruction writes to memory and returns the address.
** Returns 0 otherwise.
*/

static int decode_dest_address(int thread_num, uint32_t opcode, uint32_t *vaddr)
{
	int areg_index, dreg_index;
	uint32_t addr_mode, base, offset;
	INSN_FORMAT insn_format;
	CPUUBICOM32State *env;

	env = threads[thread_num];

	insn_format = insn_identify_format(opcode);

	switch (insn_format) {

		case INSN_FORMAT_1C: case INSN_FORMAT_1D:
		case INSN_FORMAT_2:
		case INSN_FORMAT_3:
		case INSN_FORMAT_6:

			/* Instruction format has an 11-bit dest encoding. */

			addr_mode = (opcode >> 16) & 0x7ff;

//			printf("addr mode: %d\n", addr_mode >> 8);

			switch (addr_mode >> 8) {

				case 0:		/* Immediate */

					return 0;

				case 1:		/* Direct register */

					return 0;

				case 2:		/* Areg + 4 bits scaled offset with pre/post-increment */

					areg_index = REGISTER_A0 + ((addr_mode >> 5) & 7);
					offset     = (addr_mode & 0x10) ? (addr_mode & 0xf) : 0;		/* Offset for this instruction is zero if post-increment */
					base       = get_register_value(env, areg_index);
					*vaddr     = base + offset * insn_operand_size(opcode);
					return 1;

				case 3:		/* Areg + Dreg */

					areg_index = REGISTER_A0 + ((addr_mode >> 5) & 7);
					dreg_index = REGISTER_D0 + (addr_mode & 0xf);
					base       = get_register_value(env, areg_index);
					offset     = get_register_value(env, dreg_index);
					*vaddr     = base + offset;
					return 1;

				default:	/* Areg + 7 bits scaled offset */

					areg_index = REGISTER_A0 + ((addr_mode >> 5) & 7);
					offset     = (((addr_mode >> 8) << 5) & 0x60) | (addr_mode & 0x1f);
					base       = get_register_value(env, areg_index);
					*vaddr     = base + offset * insn_operand_size(opcode);
					return 1;
			}

		default:
			break;
	}

	return 1;
}

/*
** static int decode_dest_register(int thread_num, uint32_t opcode, int *dest_thread, int *dest_reg)
**
** Returns 1 if an instruction writes to memory and returns the address.
** Returns 0 otherwise.
*/

static int decode_dest_register(int thread_num, uint32_t opcode, int *dest_thread, int *dest_reg)
{
	int areg_index, dreg_index;
	uint32_t addr_mode, base, offset;
	INSN_FORMAT insn_format;
	CPUUBICOM32State *env;

	env = threads[thread_num];

	insn_format = insn_identify_format(opcode);

	switch (insn_format) {

		case INSN_FORMAT_1C: case INSN_FORMAT_1D:
		case INSN_FORMAT_2:
		case INSN_FORMAT_3:
		case INSN_FORMAT_6:

			/* Instruction format has an 11-bit dest encoding. */

			addr_mode = (opcode >> 16) & 0x7ff;

			switch (addr_mode >> 8) {

				case 1:		/* Direct register */

					*dest_thread = (env->thread_regs[REGISTER_CSR] & BIT_14) ? ((env->thread_regs[REGISTER_CSR] >> 15) & 0x1f) : thread_num;
					*dest_reg    = (opcode >> 16) & 0xff;

					return 1;

				default:	/* Everything else */

					return 0;
			}

		default:
			break;
	}

	return 1;
}

/*************************************
* End instruction disassembler
*************************************/
/*************************************
* Start verification limits code
*************************************/

/*
** static int is_verifiable_register(int register_num)
**
** Determine if changes to a register should be verfied.
**
** Returns 1 if true, 0 if false.
*/

static int is_verifiable_register(int register_num);
static int is_verifiable_register(int register_num)
{
	switch (register_num) {

		case REGISTER_D0:
		case REGISTER_D1:
		case REGISTER_D2:
		case REGISTER_D3:
		case REGISTER_D4:
		case REGISTER_D5:
		case REGISTER_D6:
		case REGISTER_D7:
		case REGISTER_D8:
		case REGISTER_D9:
		case REGISTER_D10:
		case REGISTER_D11:
		case REGISTER_D12:
		case REGISTER_D13:
		case REGISTER_D14:
		case REGISTER_D15:

		case REGISTER_A0:
		case REGISTER_A1:
		case REGISTER_A2:
		case REGISTER_A3:
		case REGISTER_A4:
		case REGISTER_A5:
		case REGISTER_A6:
		case REGISTER_A7:

		case REGISTER_CSR:
		case REGISTER_UCSR:

		case REGISTER_SOURCE3:
		case REGISTER_IREAD_DATA:

		case REGISTER_ACC0_LO:
		case REGISTER_ACC0_HI:
		case REGISTER_MAC_RC16:
		case REGISTER_ACC1_HI:
		case REGISTER_ACC1_LO:

		/* INT_MASK0 - INT_MASK2 are not verifiable because they are delayed registers */

		case REGISTER_SCRATCHPAD0:
		case REGISTER_SCRATCHPAD1:
		case REGISTER_SCRATCHPAD2:
		case REGISTER_SCRATCHPAD3:
		case REGISTER_SCRATCHPAD4:
		case REGISTER_SCRATCHPAD5:

			return 1;

	}

	return 0;
}

/*
** static int is_verifiable_source_register(int register_num)
**
** Determine if the entire source register is verifiable.
**
** Returns 1 if true, 0 if false.
*/

static int is_verifiable_source_register(int register_num);
static int is_verifiable_source_register(int register_num)
{
//	printf("is_verifiable_source_register(%d)\n", register_num);

	switch (register_num) {

		case REGISTER_D0:
		case REGISTER_D1:
		case REGISTER_D2:
		case REGISTER_D3:
		case REGISTER_D4:
		case REGISTER_D5:
		case REGISTER_D6:
		case REGISTER_D7:
		case REGISTER_D8:
		case REGISTER_D9:
		case REGISTER_D10:
		case REGISTER_D11:
		case REGISTER_D12:
		case REGISTER_D13:
		case REGISTER_D14:
		case REGISTER_D15:

		case REGISTER_A0:
		case REGISTER_A1:
		case REGISTER_A2:
		case REGISTER_A3:
		case REGISTER_A4:
		case REGISTER_A5:
		case REGISTER_A6:
		case REGISTER_A7:

		/* CSR and UCSR are not verifiable source registers because they contain the DSP overflow bit (bit 20) */

		case REGISTER_SOURCE3:
		case REGISTER_IREAD_DATA:

		case REGISTER_ACC0_LO:
		case REGISTER_ACC0_HI:
		case REGISTER_MAC_RC16:
		case REGISTER_ACC1_HI:
		case REGISTER_ACC1_LO:

		/* INT_MASK0 - INT_MASK2 are not verifiable because they are delayed registers */

		case REGISTER_SCRATCHPAD0:
		case REGISTER_SCRATCHPAD1:
		case REGISTER_SCRATCHPAD2:
		case REGISTER_SCRATCHPAD3:
		case REGISTER_SCRATCHPAD4:
		case REGISTER_SCRATCHPAD5:

		/* SEP must be verifiable otherwise "RET SEP" and other instructions will not execute properly. */

		case REGISTER_SEP:

//			printf("return 1\n");
			return 1;
	}

//	printf("return 0\n");
	return 0;
}

/*
** static int is_verifiable_address(uint32_t paddr, int write_flag)
**
** Determine if a memory location is verifiable for a read.
**
** Returns 1 if true, 0 if false.
*/

static int is_verifiable_address(uint32_t paddr, int write_flag);
static int is_verifiable_address(uint32_t paddr, int write_flag)
{
	/* Flash is only valid for read */

	if (write_flag) {

		/* Writes to the PASS or FAIL address are legal even though they are in flash */

		if ((paddr == 0xb03fffe0) || (paddr == 0xb03fffc0))
			return 1;

		if (IS_FLASH_ADDRESS(paddr)) {

			/* Writes to flash are illegal unless -no-flash-write-check is specified. */

			if (flash_write_check_flag) {
				printf("Error: instruction wrote to flash address 0x%x.\n", paddr);
				printf("This is probably a test bug.\n");
				archrefcompare_abort();
			} else
				return 1;
		}

		/* All other writes are verifiable */

		return 1;

	} else {

		/* Any reads outside of mapped, flash, OCM, and DRAM ranges are to peripheral registers,
		   and therefore cannot be verified. */

		if (IS_FLASH_ADDRESS(paddr))
			return 1;

		if (IS_MAPPED_ADDRESS(paddr))
			return 1;

		if (IS_OCM_ADDRESS(paddr))
			return 1;

		if (IS_DRAM_ADDRESS(paddr))
			return 1;

		return 0;
	}

	return 0;
}

static int is_address_mode_verifiable(int thread_num, int addr_mode, int operand_size, int write_flag)
{
	int areg_index, dreg_index;
	uint32_t address, offset;
	CPUUBICOM32State *env;

	env = threads[thread_num];

	/* Check if the instruction has a addr_mode which is not verifiable */

//	printf("checking addr mode: 0x%x (%d)\n", addr_mode);

	switch (addr_mode >> 8) {

		case 0:		/* Immediate */

			break;

		case 1:		/* Direct register */

			if (write_flag)		/* All destination register are verifiable */
				return 1;

			if (!is_verifiable_source_register(SOURCE11_REGISTER_NUM(addr_mode)))
				return 0;

			break;

		case 2:		/* Areg + 4 bits scaled offset with pre/post-increment */

			areg_index = REGISTER_A0 + ((addr_mode >> 5) & 7);
			address    = get_register_value(env, areg_index);
			offset     = addr_mode & 0xf;

			if (!is_verifiable_address(address + offset * operand_size, write_flag))
				return 0;

			break;

		case 3:		/* Areg + Dreg */

			areg_index = REGISTER_A0 + ((addr_mode >> 5) & 7);
			dreg_index = REGISTER_D0 + (addr_mode & 0xf);
			address = get_register_value(env, areg_index);
			offset  = get_register_value(env, dreg_index);

			if (!is_verifiable_address(address + offset, write_flag))
				return 0;

			break;

		default:	/* Areg + 7 bits scaled offset */

			areg_index = REGISTER_A0 + ((addr_mode >> 5) & 7);
			address    = get_register_value(env, areg_index);
			offset     = (((addr_mode >> 8) << 5) & 0x60) | (addr_mode & 0x1f);

			if (!is_verifiable_address(address + offset * operand_size, write_flag))
				return 0;

			break;
	}

	return 1;
}

/*
** static int is_insn_verifiable_special_case(uint32_t opcode)
**
** Returns 1 if insn is a special case and verifiable
** Returns 0 if insn is a special case and not verifiable
** Returns -1 if a general case
*/

static int is_insn_verifiable_special_case(uint32_t opcode)
{
	uint32_t major_op, opcode_ext, reg_num, bit_num;

	major_op = opcode >> 26;

	switch (major_op) {

		case 0x00:

			opcode_ext = (opcode >> 11) & 0x1f;

			switch (opcode_ext) {

				case 0x1c:	/* LEA.4 */
				case 0x1d:	/* LEA.2 */
				case 0x1f:	/* LEA.1 */

					return 1;
			}

			break;

		case 0x04:	/* BSET */
		case 0x05:	/* BCLR */

			reg_num = opcode & 0xff;
			bit_num = (opcode >> 11) & 0x1f;

			switch (reg_num) {

#ifdef NO_FPU_TRAP_CHECK
				case REGISTER_CSR:

					if ((bit_num >= 23) && (bit_num <= 27))		/* Floating point trap status bits */
						return 0;

					break;
#endif
				case REGISTER_ROSR:

					if (bit_num < 2)				/* Interrupt condition or mem busy bit */
						return 0;
#ifdef NO_BTB_CHECK
					if ((bit_num >= 8) && (bit_num <= 11))		/* BTB status bits */
						return 0;
#endif
					break;

				case REGISTER_UCSR:
#ifdef NO_FPU_TRAP_CHECK
					if ((bit_num >= 15) && (bit_num <= 19))		/* Floating point exception sticky bits */
						return 0;
#endif
					if (bit_num == 20)				/* DSP sticky overflow bit */
						return 0;

					break;
			}

			break;

		case 0x38: case 0x39:	/* 11100X MOVEAI */
		case 0x3a: case 0x3b:	/* 11101X MOVEAIH */

				return 1;
	}

	return -1;
}

/*
** static int is_insn_verifiable(int thread_num, uint32_t opcode)
**
** Returns 1 if an instruction is verifiable, e.g. depends only on bits which are emulated properly in the simulation environment.
** Returns 0 otherwise.
*/

static int is_insn_verifiable(int thread_num, uint32_t opcode)
{
	INSN_FORMAT insn_format;
	int flag, source11_flag, dest11_flag, operand_size;
	uint32_t source1, dest;

	/* Perform a trivial check for the special cases */

	if ((flag = is_insn_verifiable_special_case(opcode)) >= 0)
		return flag;

	source1 = opcode & 0x7ff;
	dest    = (opcode >> 16) & 0x7ff;

	source11_flag = dest11_flag = 0;

	insn_format = insn_identify_format(opcode);

	switch (insn_format) {

		case INSN_FORMAT_1B:
		case INSN_FORMAT_4A:
		case INSN_FORMAT_4B:
		case INSN_FORMAT_5:
		case INSN_FORMAT_10A:
		case INSN_FORMAT_10B:
		case INSN_FORMAT_11A:
		case INSN_FORMAT_11B:
		case INSN_FORMAT_11C:
		case INSN_FORMAT_11D:

			source11_flag = 1;
			break;

		case INSN_FORMAT_1C:
		case INSN_FORMAT_6:

			dest11_flag = 1;
			break;

		case INSN_FORMAT_1D:
		case INSN_FORMAT_2:
		case INSN_FORMAT_3:

			source11_flag = dest11_flag = 1;
			break;

		default:
			break;
	}

	operand_size = insn_operand_size(opcode);

	if (source11_flag && !is_address_mode_verifiable(thread_num, source1, operand_size, 0)) {
//		printf("    failed source1 verifiable check\n");
		return 0;
	}

	if (dest11_flag && !is_address_mode_verifiable(thread_num, dest, operand_size, 1)) {
//		printf("    failed dest verifiable check\n");
		return 0;
	}

	return 1;
}

/*************************************
* End verification limits code
*************************************/
/*************************************
* Start register name code
*************************************/

/*
** static char *get_register_name(int register_num)
**
** Convert a register number to a register name.
*/

static char *get_register_name(int register_num);
static char *get_register_name(int register_num)
{
	int i;
	static char reg_name[16];

	for (i=0; i<sizeof(ubicom32_reg_info); i++) {

		if (ubicom32_reg_info[i].num == register_num)
			return (char *)ubicom32_reg_info[i].name;
	}

	sprintf(reg_name, "%x", register_num);

	return reg_name;
}

/*
** static int identify_register_number(char *register_name, UBICOM32_REGISTER *register_num)
**
** Convert a register name to a register number.
*/

static int identify_register_number(char *register_name, UBICOM32_REGISTER *register_num);
static int identify_register_number(char *register_name, UBICOM32_REGISTER *register_num)
{
	int i, array_size;

	array_size = sizeof(ubicom32_reg_info) / sizeof(ubicom32_reg_info[0]);

	for (i=0; i<array_size; i++) {

		if (!strcmp(ubicom32_reg_info[i].name, register_name)) {
			*register_num = ubicom32_reg_info[i].num;
			return 1;
		}
	}

	*register_num = -1;

	return 0;
}

/*
** static int hex_to_int(char *buffer, uint32_t *value)
**
** Convert a hex ASCII number to an integer value.
*/

static int hex_to_int(char *buffer, uint32_t *value);
static int hex_to_int(char *buffer, uint32_t *value)
{
	int i, len;

	*value = 0;

	len = strlen(buffer);

	for (i=0; i<len; i++) {

		*value *= 16;

		if ((buffer[i] >= '0') && (buffer[i] <= '9'))
			*value += buffer[i] - '0';
		else if ((buffer[i] >= 'a') && (buffer[i] <= 'f'))
			*value += 10 + (buffer[i] - 'a');
		else if ((buffer[i] >= 'A') && (buffer[i] <= 'F'))
			*value += 10 + (buffer[i] - 'A');
		else
			return 0;
	}

	return 1;
}

/*
** static int hex_to_int_plus_mask(char *buffer, uint32_t *value, uint32_t *mask)
**
** Convert a hex ASCII number to an integer and generate a mask.
*/

static int hex_to_int_plus_mask(char *buffer, uint32_t *value, uint32_t *mask);
static int hex_to_int_plus_mask(char *buffer, uint32_t *value, uint32_t *mask)
{
	char c;
	int i, len;

	*value = *mask = 0;

	len = strlen(buffer);

//	printf("hex_to_int_plus_mask(): %s\n", buffer);

	for (i=0; i<len; i++) {

		c = buffer[i];

		*value <<= 4;
		*mask  <<= 4;

		if ((c >= '0') && (c <= '9')) {
			*value += c - '0';
			*mask |= 0xf;
		} else if ((c >= 'a') && (c <= 'f')) {
			*value += 10 + (c - 'a');
			*mask |= 0xf;
		} else if ((c >= 'A') && (c <= 'F')) {
			*value += 10 + (c - 'A');
			*mask |= 0xf;
		} else if ((c == 'x') || (c == 'X') || (c == '-'))
			;
		else {
			printf("invalid character %c in hex string\n", c);
			archrefcompare_abort();
		}
	}

//	printf("    value: %08x, mask: %08x\n", *value, *mask);

	return 1;
}

/*
** int identify_thread_and_register(char *reg_name, int *thread_num, UBICOM32_REGISTER *register_num)
**
** Parse a string (such as [0][A0]) and extract the thread number and the register number.
*/

int identify_thread_and_register(char *reg_name, int *thread_num, UBICOM32_REGISTER *register_num);
int identify_thread_and_register(char *reg_name, int *thread_num, UBICOM32_REGISTER *register_num)
{
	char c, temp[2], thread_buffer[32], register_buffer[32];
	int i, state_num, length, flag;

	thread_buffer[0] = register_buffer[0] = temp[1] = 0;
	length = strlen(reg_name);

	state_num = 0;

	for (i=0; (i<length); i++) {

		c = reg_name[i];

		if (!c)
			break;

		switch (state_num) {

			case 0:		/* State 0: should receive '[' */

				if (c == '[')
					state_num = 1;
				else
					state_num = -1;

				break;

			case 1:		/* State 1: should receive alphanumeric or '_' only */

				if (isalnum(c) || (c == '_')) {
					temp[0] = c;
					strcat(thread_buffer, temp);
				} else if (c == ']')
					state_num = 2;
				else
					state_num = -1;

				break;

			case 2:		/* State 2: should receive '[' */

				if (c == '[')
					state_num = 3;
				else
					state_num = -1;

				break;

			case 3: 	/* State 3: should receive alphanumeric or '_' only */

				if (isalnum(c) || (c == '_')) {
					temp[0] = c;
					strcat(register_buffer, temp);
				} else if (c == ']')
					state_num = 4;
				else
					state_num = -1;

				break;

			case 4:		/* State 4: after ']' */

				state_num = -1;
				break;
		}
	}

	if (state_num == 2) {

		/* If the state_num is 2, then we parsed only a single bracketed string ([...]).
		   In this case, the register is either a hexadecimal number such as 000001f8 or global register such as GLOBAL_CTRL. */

		*thread_num = 0;

		flag = identify_register_number(thread_buffer, register_num);

		return flag;

	} else if (state_num == 4) {

		/* If the state_num is 4, then we parsed two sets of bracketed strings ([...][...]).
		   In this case, we have both a thread number and a register name. */

		hex_to_int(thread_buffer, thread_num);

		return identify_register_number(register_buffer, register_num);
	}

	return 0;
}

/*************************************
* End register name code
*************************************/
/*************************************
* Start noncacheable read buffer
*************************************/

typedef struct {

	int valid_flag;
	uint32_t vaddr, paddr;

	int restore_flag;
	uint32_t restore_value, restore_mask;

	int rollback_flag;
	uint32_t rollback_value, rollback_mask;

} NC_READ_ENTRY;

NC_READ_ENTRY nc_read_array[HW_THREADS_NUM];

/*
** void NC_Read_Store(int thread_num, uint32_t vaddr, uint32_t paddr)
**
** Save the value at the address of a noncacheable read request so the value
** can be retrieved later.
*/

void NC_Read_Store(int thread_num, uint32_t vaddr, uint32_t paddr)
{
	uint32_t value;
	NC_READ_ENTRY *entry;

	if (thread_num >= HW_THREADS_NUM) {
		printf("ERROR: Tried to store to NC read buffer for illegal thread %d\n", thread_num);
		archrefcompare_abort();
	}

	if ((vaddr & 3) || (paddr & 3)) {
		printf("ERROR: Expected noncacheable read vaddr and paddr to be 32-bit aligned\n");
		archrefcompare_abort();
	}

	entry = &nc_read_array[thread_num];

	if (entry->valid_flag && (entry->vaddr == vaddr)) {
		if (archrefcompare_debug_flag)
			printf("    Ignoring reading from noncacheable vaddr 0x%08x (already saved)\n", vaddr);
		return;
	}

	cpu_physical_memory_read(paddr, (uint8_t *)&value, 4);
	value = htonl(value);

	entry->vaddr = vaddr;
	entry->paddr = paddr;
	entry->rollback_value = value;

	if (archrefcompare_debug_flag)
		printf("    Saved to NC read buffer: thread: %x, vaddr: 0x%08x, paddr: 0x%08x, value: 0x%08x\n",
			thread_num, entry->vaddr, entry->paddr, entry->rollback_value);

	entry->valid_flag = 1;
}

/*
** int NC_Read_Check(int thread_num, uint32_t vaddr, uint32_t *paddr, uint32_t *value);
**
** Check if an instruction is reading the data retrieved by a previous noncacheable read request.
*/

int NC_Read_Check(int thread_num, uint32_t vaddr, uint32_t *paddr, uint32_t *value);
int NC_Read_Check(int thread_num, uint32_t vaddr, uint32_t *paddr, uint32_t *value)
{
	NC_READ_ENTRY *entry;

	if (thread_num >= HW_THREADS_NUM) {
		printf("ERROR: Tried to check noncacheable read value for illegal thread %d\n", thread_num);
		archrefcompare_abort();
	}

	entry = &nc_read_array[thread_num];

	/* entry->vaddr is always 32-bit aligned. */

	if (!entry->valid_flag) {

		if (archrefcompare_debug_flag)
			printf("    Miss on NC read buffer: entry not valid\n");

		return 0;
	}

	if (((vaddr & 0xfffffffc) != entry->vaddr)) {

		if (archrefcompare_debug_flag)
			printf("    Miss on NC read buffer: address does not match; entry has thread: %d, vaddr: 0x%08x, paddr: 0x%08x, value: 0x%08x\n",
				thread_num, entry->vaddr, entry->paddr, entry->rollback_value);
		return 0;
	}

	*paddr = entry->paddr;
	*value = entry->rollback_value;

	entry->valid_flag = 0;

	if (archrefcompare_debug_flag)
		printf("    Hit on NC read buffer for thread: %d, vaddr: 0x%08x, paddr: 0x%08x, value: 0x%08x\n",
			thread_num, entry->vaddr, entry->paddr, entry->rollback_value);

	return 1;
}

/*
** void NC_Read_Clear(int thread_num, int asid, uint32_t vaddr)
**
** Clear a valid read from a previous NC Read.
*/

void NC_Read_Clear(int thread_num, int asid, uint32_t vaddr);
void NC_Read_Clear(int thread_num, int asid, uint32_t vaddr)
{
	NC_READ_ENTRY *entry;

	entry = &nc_read_array[thread_num];

	if (!entry->valid_flag) {
		printf("Warning: NC Bypass without previous NC Read\n");
		return;
	}

	if (entry->vaddr != vaddr) {
		printf("Warning: NC Bypass did not match address in buffer; ignored (0x%08x != 0x%08x)\n", entry->vaddr, vaddr);
		return;
	}

	entry->valid_flag = 0;
}

/*
** void NC_Read_Restore_Value(int thread_num)
**
** Undo the result of a rollback operation if necessary.
*/

void NC_Read_Restore_Value(int thread_num);
void NC_Read_Restore_Value(int thread_num)
{
	uint32_t old_value, new_value;
	NC_READ_ENTRY *entry;

	entry = &nc_read_array[thread_num];

	if (!entry->restore_flag)
		return;

	entry->restore_flag = 0;

	cpu_physical_memory_read(entry->paddr, (uint8_t *)&old_value, 4);
	old_value = htonl(old_value);

	new_value = (old_value & ~entry->restore_mask) | (entry->restore_value & entry->restore_mask);
	new_value = htonl(new_value);

	cpu_physical_memory_write(entry->paddr, (uint8_t *)&new_value, 4);
}

/*
** void NC_Read_Rollback_Value(int thread_num)
**
** Rollback a memory location to a previous value for an instrution which performs an uncached read.
*/

void NC_Read_Rollback_Value(int thread_num);
void NC_Read_Rollback_Value(int thread_num)
{
	uint32_t new_value;
	NC_READ_ENTRY *entry;

	entry = &nc_read_array[thread_num];

	if (!entry->rollback_flag)
		return;

	entry->rollback_flag = 0;

	new_value = htonl(entry->rollback_value);
	cpu_physical_memory_write(entry->paddr, (uint8_t *)&new_value, 4);
}

/*
** void NC_Read_Generate_Rollback_And_Restore(int thread_num, uint64_t cycle, int write_flag, uint32_t source1_vaddr, uint32_t dest_vaddr, int size)
**
** Generate a rollback and restore of a memory location (if necessary) for an instruction which performs a noncacheable read.
*/

void NC_Read_Generate_Rollback_And_Restore(int thread_num, uint64_t cycle, int write_flag, uint32_t source1_vaddr, uint32_t dest_vaddr, int size);
void NC_Read_Generate_Rollback_And_Restore(int thread_num, uint64_t cycle, int write_flag, uint32_t source1_vaddr, uint32_t dest_vaddr, int size)
{
	static uint32_t bitmask[5] = { 0, 0xff000000, 0xffff0000, 0, 0xffffffff };
	NC_READ_ENTRY *entry;

	entry = &nc_read_array[thread_num];

	/* Read the current value of the memory location */

	cpu_physical_memory_read(entry->paddr, (uint8_t *)&entry->restore_value, 4);
	entry->restore_value = htonl(entry->restore_value);

	/* If the value at the address of the noncacheable read request has not been modified between the NC Read line and
	   the instruction which uses the noncacheable value, then no action is required. */

	if (entry->rollback_value == entry->restore_value) {
		if (archrefcompare_debug_flag) {
			printf("    No rollback/restore necessary; noncacheable value was not modified between NC read and graduated insn\n");
			return;
		}
	}

	if (archrefcompare_debug_flag) {
		printf("    Noncacheable value at paddr 0x%08x was modified between NC read and graduated insn\n", entry->paddr);
		printf("    Value at time of NC read: 0x%08x, current value in memory: 0x%08x\n", entry->rollback_value, entry->restore_value);
	}

	if (write_flag && (source1_vaddr & ~3) == (dest_vaddr & ~3)) {

		/* source1 and dest are in the same 32-bit word, so we need to generate bitmasks for the rollback/restore */

		/* Generate a rollback for the bits which are read by the instruction */

		entry->rollback_flag  = 1;
		entry->rollback_value = entry->rollback_value;
		entry->rollback_mask  = bitmask[size] >> ((source1_vaddr & 3) << 3);

		if (archrefcompare_debug_flag)
			printf("    generating rollback to previous value: cycle: %lld, paddr: 0x%08x, value: 0x%08x, mask: 0x%08x\n",
				cycle, entry->paddr, entry->rollback_value, entry->rollback_mask);

		/* Generate a restore for the bits which are read by the instruction, but not written by the instruction */

		entry->restore_mask = entry->rollback_mask & ~(bitmask[size] >> ((dest_vaddr & 3) << 3));

		if (entry->restore_mask) {

			entry->restore_flag = 1;

			if (archrefcompare_debug_flag)
				printf("    generating restore to current value: cycle: %lld, paddr: 0x%08x, value: 0x%08x, mask: 0x%08x\n",
					cycle + 1, entry->paddr, entry->restore_value, entry->restore_mask);
		}

	} else {

		/* source1 and dest are not in the same 32-bit word, so generate a simple rollback/restore */

		entry->rollback_flag = entry->restore_flag = 1;
		entry->restore_mask  = -1;

		if (archrefcompare_debug_flag) {
			printf("    generating rollback to previous value: cycle: %lld, paddr: 0x%08x, value: 0x%08x, mask: 0x%08x\n",
				cycle, entry->paddr, entry->rollback_value, -1);
			printf("    generating restore to current value: cycle: %lld, paddr: 0x%08x, value: 0x%08x, mask: 0x%08x\n",
				cycle + 1, entry->paddr, entry->restore_value, -1);
		}
	}
}

void NC_Read_Handler(int thread_num, uint32_t opcode, uint64_t cycle);
void NC_Read_Handler(int thread_num, uint32_t opcode, uint64_t cycle)
{
	int write_flag, operand_size;
	uint32_t source1_vaddr, dest_vaddr, paddr, value;

	/* Check if the instruction reads a memory location */

	if (decode_source1_address(thread_num, opcode, &source1_vaddr)) {

		if (archrefcompare_debug_flag)
			printf("insn reads address 0x%08x\n", source1_vaddr);

		/* Check if the instruction reads the memory location of a previous NC read line */

		if (NC_Read_Check(thread_num, source1_vaddr, &paddr, &value)) {

			/* Generate a rollback and restore for the memory location */

			write_flag = decode_dest_address(thread_num, opcode, &dest_vaddr);

			operand_size = insn_operand_size(opcode);

			NC_Read_Generate_Rollback_And_Restore(thread_num, cycle, write_flag, source1_vaddr, dest_vaddr, operand_size);
		}
	}
}

/*************************************
* End noncacheable read buffer
*************************************/
/*************************************
* Start state change queuing code
*************************************/

/*
** The typical state change types are:
**
** backdoor memory update:       action = MODIFY, change_type = MEMORY_TYPE
** TLB update:                   action = MODIFY, change_type = ITLB_TYPE/DTLB_TYPE
** controlled register update:   action = MODIFY, change_type = REGISTER_TYPE
** memory/register verification: action = VERIFY, change_type = REGISTER_TYPE/MEMORY_TYPE
*/

typedef enum {

	MODIFY,
	VERIFY

} ACTION;

typedef enum {

	REGISTER_TYPE,
	MEMORY_TYPE,
	DTLB_TYPE,
	ITLB_TYPE,
	NC_READ_TYPE,
	NC_CLEAR_TYPE

} CHANGE_TYPE;

typedef enum {

	PROCESS_TLB,
	PROCESS_ALL

} PROCESS_TYPE;

typedef struct STATE_CHANGE_TAG {

	struct STATE_CHANGE_TAG *prev, *next;

	uint64_t cycle;				/* This value is the cycle on which this action should take effect.
						   If an instruction executions on cycle N, all actions for cycle N will be executed
						   before the instruction is executed. */

	ACTION action;				/* The action to perform on aforementioned cycle, either MODIFY or VERIFY. */

	CHANGE_TYPE type;			/* The operand type of the action, either REGISTER_TYPE, MEMORY_TYPE, DTLB_TYPE or ITLB_TYPE. */

	int thread;
	uint32_t index, index2, value, mask;
	uint64_t value64;			/* This value64 is only used for TLB updates which require a 64-bit value. */

} STATE_CHANGE;

STATE_CHANGE state_change_anchor;

/*
** static void state_change_init_change_list(void)
**
** Initialize the state change list
*/

static void state_change_init_change_list(void);
static void state_change_init_change_list(void)
{
	if (!state_change_anchor.next)
		state_change_anchor.prev = state_change_anchor.next = &state_change_anchor;
}

/*
** static STATE_CHANGE *state_change_add_change(uint64_t cycle, ACTION action, CHANGE_TYPE type, int thread, int index, uint32_t value, uint64_t mask)
**
** Add a change to the state change list.
*/

static STATE_CHANGE *state_change_add_change(uint64_t cycle, ACTION action, CHANGE_TYPE type, int thread, int index, uint32_t value, uint64_t mask);
static STATE_CHANGE *state_change_add_change(uint64_t cycle, ACTION action, CHANGE_TYPE type, int thread, int index, uint32_t value, uint64_t mask)
{
	STATE_CHANGE *state_change;

	state_change = malloc(sizeof(*state_change));

	state_change->cycle  = cycle;
	state_change->action = action;
	state_change->type   = type;
	state_change->thread = thread;
	state_change->index  = index;
	state_change->value  = value;
	state_change->mask   = mask;

	/* Append the node */

	state_change->prev = state_change_anchor.prev;
	state_change->next = &state_change_anchor;

	state_change->prev->next = state_change->next->prev = state_change;

	return state_change;
}

/*
** static STATE_CHANGE *state_change_add_change_index2(uint64_t cycle, ACTION action, CHANGE_TYPE type, int thread, int index, int index2, uint32_t value, uint64_t mask)
**
** Add a change to the state change list with two indexes.
*/

static STATE_CHANGE *state_change_add_change_index2(uint64_t cycle, ACTION action, CHANGE_TYPE type, int thread, int index, int index2, uint32_t value, uint64_t mask);
static STATE_CHANGE *state_change_add_change_index2(uint64_t cycle, ACTION action, CHANGE_TYPE type, int thread, int index, int index2, uint32_t value, uint64_t mask)
{
	STATE_CHANGE *state_change;

	state_change = malloc(sizeof(*state_change));

	state_change->cycle  = cycle;
	state_change->action = action;
	state_change->type   = type;
	state_change->thread = thread;
	state_change->index  = index;
	state_change->index2 = index2;
	state_change->value  = value;
	state_change->mask   = mask;

	/* Append the node */

	state_change->prev = state_change_anchor.prev;
	state_change->next = &state_change_anchor;

	state_change->prev->next = state_change->next->prev = state_change;

	return state_change;
}
/*
** static STATE_CHANGE *state_change_add_change64(uint64_t cycle, ACTION action, CHANGE_TYPE type, int thread, int index, uint64_t value64, uint64_t mask64)
**
** Append a change to the state change list with a 64-bit value;
*/

static STATE_CHANGE *state_change_add_change64(uint64_t cycle, ACTION action, CHANGE_TYPE type, int thread, int index, uint64_t value64, uint64_t mask64);
static STATE_CHANGE *state_change_add_change64(uint64_t cycle, ACTION action, CHANGE_TYPE type, int thread, int index, uint64_t value64, uint64_t mask64)
{
	STATE_CHANGE *state_change;

	state_change = malloc(sizeof(*state_change));

	state_change->cycle  = cycle;
	state_change->action  = action;
	state_change->type    = type;
	state_change->thread  = thread;
	state_change->index   = index;
	state_change->value64 = value64;
	state_change->mask    = mask64;

	state_change->prev = state_change_anchor.prev;
	state_change->next = &state_change_anchor;

	state_change->prev->next = state_change->next->prev = state_change;

	return state_change;
}

/*
** void state_change_remove_and_free(STATE_CHANGE *state_change)
**
** Remove a state change from the list, and free the memory.
*/

void state_change_remove_and_free(STATE_CHANGE *state_change);
void state_change_remove_and_free(STATE_CHANGE *state_change)
{
	state_change->prev->next = state_change->next;
	state_change->next->prev = state_change->prev;

	free(state_change);
}

/*
** static void state_change_convert_verify_to_modify(uint64_t cycle, int thread, int index)
**
** Convert a VERIFY of a register in the state change list to a MODIFY.
*/

static void state_change_convert_verify_to_modify(uint64_t cycle, int index)
{
	STATE_CHANGE *state_change;

	for (state_change = state_change_anchor.next; state_change != &state_change_anchor; state_change = state_change->next) {

		/* We don't need to check the thread because we don't have the info, and the change occurs on the current cycle. */

		if ((state_change->cycle != cycle) || (state_change->action != VERIFY) || (state_change->index != index))
			continue;

		/* Update the state change so instead of a VERIFY for the current cycle, it becomes a MODIFY for the next cycle. */

		state_change->action = MODIFY;
		state_change->cycle++;
	}
}

/*
** static void state_change_process_changes(uint64_t cycle, PROCESS_TYPE process_type)
**
** Process the changes which should happen in the current (or previous) cycles.
*/

static void state_change_process_changes(uint64_t cycle, PROCESS_TYPE process_type);
static void state_change_process_changes(uint64_t cycle, PROCESS_TYPE process_type)
{
	uint32_t old_value, write_value, read_value;
	STATE_CHANGE *state_change, *next_change;
	CPUUBICOM32State *state;

	if (archrefcompare_debug_flag) {

		if (state_change == &state_change_anchor)
			printf("processing state change list at cycle %lld...state change list is empty\n", cycle);
		else
			printf("processing state change list at cycle %lld...\n", cycle);
	}

	for (state_change = state_change_anchor.next; state_change != &state_change_anchor; state_change = next_change) {

		next_change = state_change->next;

		if ((state_change->cycle > cycle) || (state_change->action != MODIFY))
			continue;

		switch (state_change->type) {

			case REGISTER_TYPE:

				if (process_type == PROCESS_TLB)
					continue;

				state = threads[state_change->thread];

				if (state_change->index < GLOBAL_REGISTER_OFFSET) {

					if (archrefcompare_debug_flag)
						printf("    Cycle %lld: MODIFY REGISTER 0x%x:%s = 0x%08x\n",
							state_change->cycle, state_change->thread, get_register_name(state_change->index), state_change->value);

					state->thread_regs[state_change->index] = state_change->value;

				} else {

					/* The program counter is handled separately. */

					if (state_change->index == REGISTER_PC)
						continue;

					if (archrefcompare_debug_flag)
						printf("    Cycle %lld: MODIFY REGISTER %s = 0x%08x\n",
							state_change->cycle, get_register_name(state_change->index), state_change->value);

					state->global_regs[state_change->index - GLOBAL_REGISTER_OFFSET] = state_change->value;
				}

				break;

			case MEMORY_TYPE:

				if (process_type == PROCESS_TLB)
					continue;

				if (archrefcompare_debug_flag)
					printf("    Cycle: %lld: MODIFY MEMORY paddr: 0x%08x, value: 0x%08x, mask: 0x%08x\n",
						state_change->cycle, state_change->index, state_change->value, state_change->mask);

				write_value = state_change->value;

				if (state_change->mask != 0xffffffff) {

					cpu_physical_memory_read(state_change->index, (uint8_t *)&old_value, 4);

					old_value = htonl(old_value);

					write_value = (write_value & state_change->mask) | (old_value & ~state_change->mask);

					printf("    paddr 0x%08x - old value: 0x%08x, new value: 0x%08x\n", state_change->index, old_value, write_value);
				}

				write_value = htonl(write_value);
				cpu_physical_memory_write(state_change->index, (uint8_t *)&write_value, 4);

				cpu_physical_memory_read(state_change->index, (uint8_t *)&read_value, 4);

				if (read_value != write_value) {
					printf("    MODIFY MEMORY failed; read value (0x%08x) does not match write value (0x%08x)\n", read_value, write_value);
					archrefcompare_abort();
                        	}

				break;

			case DTLB_TYPE:

				if (archrefcompare_debug_flag)
					printf("    Cycle %lld: MODIFY DATA TLB, index: 0x%08x, value: 0x%016llx\n",
						state_change->cycle, state_change->index, state_change->value64);

				TLB_write(state_change->index, state_change->value64, 0);
				break;

			case ITLB_TYPE:

				if (archrefcompare_debug_flag)
					printf("    Cycle %lld: MODIFY INSN TLB, index: 0x%08x, value: 0x%016llx\n",
						state_change->cycle, state_change->index, state_change->value64);

				TLB_write(state_change->index, state_change->value64, 1);
				break;

			case NC_READ_TYPE:

				if (archrefcompare_debug_flag)
					printf("    Cycle %lld: MODIFY NC READ, paddr: 0x%08x, value: 0x%016llx\n",
						state_change->cycle, state_change->index, state_change->value64);

				NC_Read_Store(state_change->thread, state_change->index, state_change->index2);
				break;

			case NC_CLEAR_TYPE:

				if (archrefcompare_debug_flag)
					printf("    Cycle %lld: MODIFY NC CLEAR, thread: 0x%x, asid: 0x%x, vaddr: 0x%08x\n",
						state_change->cycle, state_change->thread, state_change->index, state_change->value);

				NC_Read_Clear(state_change->thread, state_change->index, state_change->value);
				break;
		}

		/* Free the state change we just processed */

		state_change_remove_and_free(state_change);
	}
}

/*
** int state_change_find_pc(uint64_t *cycle, int *thread_num, uint32_t *pc_value)
**
** Find the thread and PC (program counter) value in the state change list.
*/

static int state_change_find_pc(uint64_t *cycle, int *thread_num, uint32_t *pc_value);
static int state_change_find_pc(uint64_t *cycle, int *thread_num, uint32_t *pc_value)
{
	STATE_CHANGE *state_change;

	for (state_change = state_change_anchor.next; state_change != &state_change_anchor; state_change = state_change->next) {

		if ((state_change->type == REGISTER_TYPE) && (state_change->index == REGISTER_PC)) {

			*cycle      = state_change->cycle;
			*thread_num = state_change->thread;
			*pc_value   = (int)state_change->value;

			state_change_remove_and_free(state_change);

			return 1;
		}
	}

	return 0;
}

/*
** static int state_change_verify(STATE_CHANGE *state_change)
**
** Check if a change actually occured.
** Returns 0 if change was verified, otherwise return 1.
*/

static int state_change_verify(STATE_CHANGE *state_change);
static int state_change_verify(STATE_CHANGE *state_change)
{
	int value;
	CPUUBICOM32State *state;

	if (state_change->action != VERIFY)
		return 0;

	switch (state_change->type) {

		case REGISTER_TYPE:

			state = threads[state_change->thread];

			if (!is_verifiable_register(state_change->index)) {

				if (archrefcompare_debug_flag)
					printf("    SKIP: register 0x%x:%s\n", state_change->thread, get_register_name(state_change->index));

				return 0;

			} else if (!check_register_value(state, state_change->index, state_change->value, state_change->mask)) {

				printf("    BAD: register 0x%x:%s is 0x%08x, expected value 0x%08x with mask 0x%08x\n",
					state_change->thread, get_register_name(state_change->index),
					state_change->value, get_register_value(state, state_change->index), state_change->mask);

				return 1;

			} else if (archrefcompare_debug_flag)
					printf("    GOOD: register 0x%x:%s is 0x%08x with mask 0x%08x\n",
							state_change->thread, get_register_name(state_change->index),
							get_register_value(state, state_change->index), state_change->mask);

			return 0;

		case MEMORY_TYPE:

			if (!insn_check_flag || !is_verifiable_address(state_change->index, 0)) {

				if (archrefcompare_debug_flag)
					printf("    SKIP: unverifiable address %08x\n", state_change->index);

				return 0;
			}

			cpu_physical_memory_read(state_change->index, (uint8_t *)&value, 4);

			value = htonl(value);

			if ((value & state_change->mask) != state_change->value) {

				printf("    BAD: address 0x%08x has value 0x%08x, expected 0x%08x with mask 0x%08x\n",
					state_change->index, state_change->value, value, state_change->mask);

				return 1;

			} else if (archrefcompare_debug_flag)
					printf("    OK: address 0x%08x has value: 0x%08x with mask 0x%08x\n", state_change->index, value, state_change->mask);
		default:

			/* Other types such as ITLB or DTLB updates do not need verification. */
			break;
	}

	return 0;
}

/*
** static void state_change_modify(STATE_CHANGE *state_change)
**
** Process a state change MODIFY node and perform any actions.
*/

static void state_change_modify(STATE_CHANGE *state_change);
static void state_change_modify(STATE_CHANGE *state_change)
{
	int old_value, new_value;
	CPUUBICOM32State *state;

	/* Do not check the action, because sometimes we need to handle a VERIFY. */

	switch (state_change->type) {

		case REGISTER_TYPE:

			/* Registers which can't be verified (such as CSR) still need to be fixed,
			   so do not skip unverifiable registers. */

			state = threads[state_change->thread];

			if (archrefcompare_debug_flag)
				printf("    FIX: register 0x%x:%s, wrote value 0x%08x\n",
					state_change->thread, get_register_name(state_change->index), state_change->value);

			set_register_value(state, state_change->index, state_change->value);

			break;

		case MEMORY_TYPE:

			if (!insn_check_flag || !is_verifiable_address(state_change->index, 1)) {

				if (archrefcompare_debug_flag)
					printf("    SKIP: unwritable address %08x\n", state_change->index);

				break;
			}

			if (archrefcompare_debug_flag)
				printf("    FIX: address 0x%08x, wrote value: 0x%08x with mask 0x%08x\n",
					state_change->index, state_change->value, state_change->mask);

			cpu_physical_memory_read(state_change->index, (uint8_t *)&old_value, 4);

			old_value = htonl(old_value);
			new_value = (state_change->value & state_change->mask) | (old_value & ~state_change->mask);
			new_value = htonl(new_value);

			cpu_physical_memory_write(state_change->index, (uint8_t *)&new_value, 4);

			break;

		default:
			break;
	}
}

/*
** int state_change_verify_changes(uint64_t cycle)
**
** Verify the register and memory changes in the state change list actually occured.
*/

static int state_change_verify_changes(uint64_t cycle);
static int state_change_verify_changes(uint64_t cycle)
{
	int miscompare_count;
	STATE_CHANGE *state_change, *next_change;

	if (archrefcompare_debug_flag) {

		if (state_change == &state_change_anchor)
			printf("verifying state change list at cycle %lld...state change list is empty\n", cycle);
		else
			printf("verifying state change list at cycle %lld...\n", cycle);
	}

	miscompare_count = 0;

	for (state_change = state_change_anchor.next; state_change != &state_change_anchor; state_change = next_change) {

		next_change = state_change->next;

		if (state_change->cycle > cycle)
			continue;

		if (state_change->action == VERIFY)
			miscompare_count += state_change_verify(state_change);
		else if (state_change->action == MODIFY)
			state_change_modify(state_change);

		/* Free the state change we just processed */

		state_change_remove_and_free(state_change);
	}

	if (miscompare_count) {
		printf("VERIFY FAILED; %d MISCOMPARE%s found at cycle %lld\n", miscompare_count, (miscompare_count > 1) ? "S" : "", cycle);
		archrefcompare_abort();
	} else if (archrefcompare_debug_flag)
		printf("verify OK: no miscompares\n");

	return !miscompare_count;
}

/*
** static void state_change_apply_changes(uint64_t cycle)
**
** Apply the changes (MODIFY items) in the state change list.
*/

static void state_change_apply_changes(uint64_t cycle);
static void state_change_apply_changes(uint64_t cycle)
{
	STATE_CHANGE *state_change, *next_change;

	if (archrefcompare_debug_flag) {

		if (state_change == &state_change_anchor)
			printf("applying state change list at cycle %lld...state change list is empty\n", cycle);
		else
			printf("applying state change list at cycle %lld...\n", cycle);
	}

	for (state_change = state_change_anchor.next; state_change != &state_change_anchor; state_change = next_change) {

		next_change = state_change->next;

		if ((state_change->cycle > cycle) || (state_change->action != VERIFY))
			continue;

		state_change_modify(state_change);

		/* Free the state change we just processed */

		state_change_remove_and_free(state_change);
	}
}

/*
** static void state_change_dump(void)
**
** Dump the entries in the state change list.
*/

static void state_change_dump(void);
static void state_change_dump(void)
{
	STATE_CHANGE *state_change;

	printf("state change list:\n");

	for (state_change = state_change_anchor.next; state_change != &state_change_anchor; state_change = state_change->next) {

		printf("    Cycle %lld, ", state_change->cycle);

		switch (state_change->action) {

			case MODIFY:

				printf("MODIFY ");
				break;

			case VERIFY:

				printf("VERIFY ");
				break;

			default:

				printf("*** BAD state_change->action VALUE *** ");
				break;
		}

		switch (state_change->type) {

			case REGISTER_TYPE:

				if (state_change->index < GLOBAL_REGISTER_OFFSET)
					printf("REGISTER_TYPE, register: 0x%x:%s (0x%x), value: 0x%x, mask: 0x%x\n",
						state_change->thread, get_register_name(state_change->index), state_change->index,
						state_change->value, state_change->mask);
				else
					printf("REGISTER_TYPE, register: %s (0x%x), value: 0x%x, mask: 0x%x\n",
						get_register_name(state_change->index), state_change->index, state_change->value, state_change->value);

				break;

			case MEMORY_TYPE:

				printf("MEMORY_TYPE, paddr: 0x%08x, value: 0x%08x, mask: 0x%08x\n", state_change->index, state_change->value, state_change->mask);
				break;

			case DTLB_TYPE:

				printf("DTLB_TYPE, tlb index: 0x%08x, value: 0x%016llx\n", state_change->index, state_change->value64);
				break;

			case ITLB_TYPE:

				printf("ITLB_TYPE, tlb index: 0x%08x, value: 0x%016llx\n", state_change->index, state_change->value64);
				break;

			case NC_READ_TYPE:

				printf("NC_READ_TYPE, paddr: 0x%08x, vaddr: %08x, value: 0x%08x\n", state_change->index, state_change->index2, state_change->value);
				break;

			case NC_CLEAR_TYPE:

				printf("NC_CLEAR_TYPE, thread: 0x%x, asid: 0x%x, vaddr: %08x\n",
					state_change->thread, state_change->index, state_change->value);

				break;

			default:

				printf("BAD state_change->type VALUE ***\n");
				break;
		}
	}
}

/*************************************
* End state change queuing code
*************************************/
/*************************************
* Start trace file parser
*************************************/

/*
** Parse a single line from the trace file
*/

static int parse_trace_file_line(char *line_buf, uint64_t *cycle);
static int parse_trace_file_line(char *line_buf, uint64_t *cycle)
{
	char id_bit, reg_name[20], data_val_str[64];
	char mnemonic[128], operand[128], junk1[128], junk2[128], junk3[128];
	int line_parsed;
	unsigned int instr_opcode, args_num, ahb_master;
	unsigned int thread, asid, vaddr, paddr, asid2, vaddr2, paddr2, value, mask, index;
	uint64_t tlb_index, tlb_value, read_cycle;
	UBICOM32_REGISTER register_num;

	line_parsed = 0;

	switch (*line_buf) {

		case '\n':
		case ';':

			// Ignore blank and comment lines

			line_parsed = 1;
			break;

		case 'A':

			/* Nothing to do for these lines. */

			if (sscanf(line_buf, "AHB%d Read Memory [%x] = %s", &ahb_master, &paddr, data_val_str) == 3)
				line_parsed = 1;
			else if (sscanf(line_buf, "AHB%d Write Memory [%x] = %s", &ahb_master, &paddr, data_val_str) == 3)
				line_parsed = 1;

			break;

		case 'B':

			/* We do not try to match the exact format because we don't track BTB updates. */

			if (sscanf(line_buf, "BTB Insertion [%x]", &index) == 1)
				line_parsed = 1;

			if (sscanf(line_buf, "BTB Invalidation [%x]", &index) == 1)
				line_parsed = 1;

			if (sscanf(line_buf, "BTB Hit [%x]", &index) == 1)
				line_parsed = 1;

			break;

		case 'C':

			// Ignore cancelled instructions

			if (!strncmp(line_buf, "Cancelled", 9))
				line_parsed = 1;

			break;

		case 'D':

			if (sscanf(line_buf, "DMA Write Memory [%x] = %s", &paddr, data_val_str) == 2) {

				line_parsed = 1;

				if (archrefcompare_debug_flag)
					printf("    DMA write to 0x%08x\n", (int)paddr);

				hex_to_int(data_val_str, &value);

				state_change_add_change(*cycle + 1, MODIFY, MEMORY_TYPE, thread, paddr, value, -1);
			}

			break;

		case 'G':

			if ((sscanf(line_buf, "Graduated : %x : %x : %x : %x : %x : %s : Cycle %lld",
			     &thread, &asid, &vaddr, &paddr, &instr_opcode, mnemonic, cycle) == 7)
		    	|| (sscanf(line_buf, "Graduated : %x : %x : %x : %x : %x : %s %s : Cycle %lld",
			    &thread, &asid, &vaddr, &paddr, &instr_opcode, mnemonic, operand, cycle) == 8)
		    	|| (sscanf(line_buf, "Graduated : %x : %x : %x : %x : %x : %s %s %s : Cycle %lld",
			    &thread, &asid, &vaddr, &paddr, &instr_opcode, mnemonic, operand, junk1, cycle) == 9)
		    	|| (sscanf(line_buf, "Graduated : %x : %x : %x : %x : %x : %s %s %s %s : Cycle %lld",
			    &thread, &asid, &vaddr, &paddr, &instr_opcode, mnemonic, operand, junk1, junk2, cycle) == 10)
		    	|| (sscanf(line_buf, "Graduated : %x : %x : %x : %x : %x : %s %s %s %s %s : Cycle %lld",
			    &thread, &asid, &vaddr, &paddr, &instr_opcode, mnemonic, operand, junk1, junk2, junk3, cycle) == 11)) {

				line_parsed = 1;

				last_pc_paddr = paddr;

				state_change_add_change(*cycle, MODIFY, REGISTER_TYPE, thread, REGISTER_PC, vaddr, -1);

				insn_cycle = *cycle;
			}

			break;

		case 'R':

			if (sscanf(line_buf, "RTL Updated Register %s = %s : Cycle %lld", reg_name, data_val_str, cycle) == 3)
				line_parsed = 1;

			break;

		case 'M':

			if (sscanf(line_buf, "MMU Read Completed : %x : %x : %s : Cycle %lld", &thread, &paddr, data_val_str, cycle) == 4) {

				/* If there are any pending TLB updates in the state change list, then they must be processed
				   before any MMU reads so the TLB update will have the correct PTEC index of the last MMU read. */

				state_change_process_changes(insn_cycle, PROCESS_TLB);
				snoop_MMU_read(paddr);
				line_parsed = 1;

			} else if (sscanf(line_buf, "MMU Read Cancelled : %x : %x : Cycle %lld", &thread, &paddr, cycle) == 3)
				line_parsed = 1;

			break;

		case 'N':

			if (sscanf(line_buf, "NC Read Request : [%x] : [%x][%x][%x] : Cycle %lld", &thread, &asid, &vaddr, &paddr, &read_cycle) == 5) {
				state_change_add_change_index2(read_cycle, MODIFY, NC_READ_TYPE, thread, vaddr, paddr, value, -1);
				line_parsed = 1;
			}

			if (sscanf(line_buf, "NC Bypass : [%x] : [%x][%x][%x]", &thread, &asid, &vaddr, &paddr) == 4) {
				state_change_add_change(*cycle, MODIFY, NC_CLEAR_TYPE, thread, asid, vaddr, -1);
				line_parsed = 1;
			}

			break;

		case 'O':

			if (sscanf(line_buf, "OCP read : %x : %s : Cycle %lld", &paddr, data_val_str, cycle) == 3) {

				/*
				** OCP reads are now ignored because we detect unverifiable instructions by
				** decoding the source1 operand and checking if it accesses non-simulated bits
				** in memory or in processor registers.
				*/

				line_parsed = 1;

			} else if (sscanf(line_buf, "OCP write : %x : %s : Cycle %lld", &paddr, data_val_str, cycle) == 3) {
				/* Ignored for now */
				line_parsed = 1;
			}

			break;

		case 'T':

			if (sscanf(line_buf, "TLB Update : %c : %lld : %llx : Cycle %lld", &id_bit, &tlb_index, &tlb_value, cycle) == 4) {

				line_parsed = 1;

				if (id_bit == 'I')
					state_change_add_change64(*cycle + 1, MODIFY, ITLB_TYPE, thread, tlb_index, tlb_value, -1);
				else
					state_change_add_change64(*cycle + 1, MODIFY, DTLB_TYPE, thread, tlb_index, tlb_value, -1);

			} else if (sscanf(line_buf, "TLB Invalidate : %c : %lld : Cycle %lld", &id_bit, &tlb_index, cycle) == 3) {

				line_parsed = 1;

				if (id_bit == 'I')
					state_change_add_change64(*cycle + 1, MODIFY, ITLB_TYPE, thread, tlb_index, 0, -1);
				else
					state_change_add_change64(*cycle + 1, MODIFY, DTLB_TYPE, thread, tlb_index, 0, -1);
			}

			break;

		case 'W':

			args_num = sscanf(line_buf, "Write Memory [%x][%x][%x] = %s [%x][%x][%x]", &asid, &vaddr, &paddr, data_val_str, &asid2, &vaddr2, &paddr2);

			if ((args_num == 4) || (args_num == 7)) {

				line_parsed = 1;

				/* Writes of "XXDEADXX" are generated by the flush instruction; don't try to verify the write. */

				if (!strcmp(data_val_str, "XXDEADXX"))
					break;

				hex_to_int_plus_mask(data_val_str, &value, &mask);

				state_change_add_change(*cycle, VERIFY, MEMORY_TYPE, -1, paddr, value, mask);

				break;
			}

			args_num = sscanf(line_buf, "Write Register %s = %s [%x][%x][%x]" , reg_name, data_val_str, &asid2, &vaddr2, &paddr2);

			if ((args_num == 2) || (args_num == 5)) {

				line_parsed = 1;

				identify_thread_and_register(reg_name, &thread, &register_num);

				value = 0xdeadbeef;

				hex_to_int_plus_mask(data_val_str, &value, &mask);
#ifdef NO_FPU_TRAP_CHECK
				if (register_num == REGISTER_CSR)
					mask &= ~0xf80000;		/* Mask out floating-point trap status bits */
				else if (register_num == REGISTER_UCSR)
					mask &= 0xff;			/* Only compare 32-bit and 16/8-bit NZCV flags */
#endif
				state_change_add_change(*cycle, VERIFY, REGISTER_TYPE, thread, register_num, value, mask);
			}

			break;
	}

	return line_parsed;
}

/*
** static int is_next_line_sequence_point(void)
**
** Check if the next line is a new instruction.
*/

static int is_next_line_sequence_point(void);
static int is_next_line_sequence_point(void)
{
	int next_char;

	next_char = fgetc(trace_file);

	ungetc(next_char, trace_file);

	/* If the next line is: "Graduated ..." then we consider it a sequence point.  */

//	printf("is_next_line_sequence_point(): %d\n", next_char == 'G');

	return (next_char == 'G');
}

/*************************************
* End trace file parser
*************************************/
/*************************************
* Start ugly kludges
*************************************/

/*
** void process_undefined_registers(int opcode, uint64_t cycle)
**
** This routine is a kludge to handle registers which are undefined after an instruction is executed.
** It synchronizes the reference model with the hardware model by copying the RTL values into QEMU.
*/

void process_undefined_registers(int opcode, uint64_t cycle);
void process_undefined_registers(int opcode, uint64_t cycle)
{
	if (((opcode & 0xfbe00000) == 0x30c00000) ||		/* MACS.4 */
	    ((opcode & 0xfbe00000) == 0x31600000)) {		/* MACU.4 */

		if (archrefcompare_debug_flag) {
			printf("Note: MACS.4 or MACU.4 instruction detected. These instructions leave MAC_HI/MAC_RC16/ACC1_HI"
				" in an undefined state.\n");
			printf("      Converting MAC_HI/MAC_RC16/ACC1_HI state changes from VERIFY to MODIFY"
				" to fix reference model state.\n");
		}

		state_change_convert_verify_to_modify(cycle, REGISTER_ACC0_HI);
		state_change_convert_verify_to_modify(cycle, REGISTER_MAC_RC16);
		state_change_convert_verify_to_modify(cycle, REGISTER_ACC1_HI);
	}
}

/*************************************
* End ugly kludges
*************************************/
/*************************************
* Start QEMU interface code
*************************************/

/*
** Open the trace file
*/

void archrefcompare_open_file(char *filename);
void archrefcompare_open_file(char *filename)
{
	if (!(trace_file = fopen(filename, "rt"))) {
		printf("Error: unable to open trace file\n");
		exit(1);
	}
}

/*
** Get the next instruction to execute from the trace file.
*/

int archrefcompare_get_next_instruction(int *thread, uint32_t *pc);
int archrefcompare_get_next_instruction(int *thread, uint32_t *pc)
{
	char line_buf [MAX_TRACE_LINE_LENGTH];
	int line_parsed, has_pc_update_flag, dest_thread, dest_reg;
	uint32_t old_pc, ref_pc, opcode;
	uint64_t cycle;

	if (archrefcompare_debug_flag) {
		printf("*** Sequence point ***\n");
		fflush(stdout);
	}

	if (feof(trace_file)) {
		printf("End of trace file\n");
		printf("Running EOT checks...\n");
		EOT_DRAM_Check();
		EOT_OCM_Check();
		printf("*** PASS ***\n");
		return 0;
	}

	state_change_init_change_list();

	NC_Read_Restore_Value(last_thread_num);

	while (!feof(trace_file)) {

		/* This is the main trace file processing loop.
		   It reads and processes lines from the trace file until it finds a "Graduated" line. */

		for (;;) {

			/* Read a line from the trace file */

			fgets(line_buf, MAX_TRACE_LINE_LENGTH, trace_file);

			if (feof(trace_file))
				break;

			/* Don't print out "Cancelled ..." lines */

			if (archrefcompare_debug_flag && (*line_buf != 'C')) {
				fflush(stdout);
				printf("processing: %s", line_buf);
			}

			/* Parse the line from the trace file */

			line_parsed = parse_trace_file_line(line_buf, &cycle);

			if (!line_parsed) {
				printf("Error parsing line: %s\n", line_buf);
				printf("Sorry unable to parse line of trace file!\n");
				archrefcompare_abort();
			}

			/* If the next line is a sequence point, then all queued upates (in current_update) must be processed
			   because the side effects need to be resolved before the sequence point. */

			if (is_next_line_sequence_point())
				break;
		}

		cpu_physical_memory_read(last_pc_paddr, (uint8_t *)&opcode, 4);

		opcode = htonl(opcode);

		has_pc_update_flag = state_change_find_pc(&cycle, thread, pc);

		if (pc_miscompare_check_flag && has_pc_update_flag && decode_dest_register(*thread, opcode, &dest_thread, &dest_reg)
		    && (*thread == dest_thread) && (dest_reg == REGISTER_PC)) {
			printf("ERROR: This test manually modifies the PC of the current thread (MOVE.4 PC,x) which is not architecturally defined.\n");
			archrefcompare_abort();
		}

		if (has_pc_update_flag) {

			ref_pc = get_register_value(threads[*thread], REGISTER_PC);

			if (pc_miscompare_check_flag && (ref_pc != *pc)) {
				printf("WARNING: Trace file PC (0x%08x) does not match reference model PC (0x%08x)\n", *pc, ref_pc);
				printf("         If instruction was skipped, the instruction may have caused a trap while traps are not enabled.\n");
				archrefcompare_abort();
			}

			/* Break out to execute the instruction with QEMU if the instruction is verifiable. */

			if (is_insn_verifiable(*thread, opcode))
				break;
		}

		/* The instruction is not verifiable. Simulate executing the instruction by applying the changes
		   to the reference model, then loop around to get the next graduated instruction. */

		if (archrefcompare_debug_flag)
			printf("Instruction or source1 operand is not verifiable; applying instruction's effects to reference model"
				" instead of executing instruction.\n");

		state_change_apply_changes(cycle);

		/* Manually update the reference model's PC if there was an instruction in this trace file fragment */

		if (has_pc_update_flag) {

			old_pc = get_register_value(threads[*thread], REGISTER_PC);

			set_register_value(threads[*thread], REGISTER_PC, old_pc + 4);
		}
	}

	/* Process the backdoor updates before we execute the instruction. */

	state_change_process_changes(insn_cycle, PROCESS_ALL);

	/* Handle special case of noncacheable reads */

	NC_Read_Handler(*thread, opcode, cycle);

	process_undefined_registers(opcode, cycle);

	if (archrefcompare_debug_flag)
		state_change_dump();

	NC_Read_Rollback_Value(last_thread_num = *thread);

	last_cycle = cycle;

	return 1;
}

/*
** Verify the changes which should have occured have actually occured.
*/

int archrefcompare_verify_changes(void);
int archrefcompare_verify_changes(void)
{
	int value;

	if (!(value = state_change_verify_changes(last_cycle)))
		fclose(trace_file);

	return value;
}

void archrefcompare_abort(void)
{
        printf("Rerun QEMU with the \"-arc-debug\" option to enable debug output\n");
        printf("** FAIL **\n");
	exit(1);
}

/*************************************
* End QEMU interface code
*************************************/
